#include <stdio.h>
#include <math.h>
#include <malloc.h>
#include <string.h>
#include <stdlib.h>
#define TER 20
#define ERR stdout
#define ACU  0.0000000001
typedef struct nodc {
   char childio[3];
   int childn[3];
 } Nodc;

extern int tr[4][4],tr1[4][4],trp[5][5],dflg;
extern char base[11],amn[24],amn1[21],*distop[18];






/*  */
int tr[4][4]={-1,1,0,1,
                1,-1,1,0,
                0,1,-1,1,
                1,0,1,-1};
int tr1[4][4]={0,3,1,3,
               3,0,3,2,
               1,3,0,3,
               3,2,3,0};



int trp[5][5]={-1,0 ,0,0,0,
                0,-1,0,0,0,
                0,0,-1,0,0,
                0,0,0,-1,0,
                0,0,0,0,-1};

int dflg=0;

char base[11]={'A','T','G','C','-','*','X','?','N','R','Y'};
char amn[24]={'A','C','D','E','F','G','H','I','K','L','M','N','P','Q',
                     'R','S','T','V','W','Y','-','?','*','X'};
char amn1[21]={'A','C','D','E','F','G','H','I','K','L','M','N','P','Q',
                     'R','S','T','V','W','Y','*'};
/* tr specifies: no change -1, transition 0, transversion 1 */
int *ivector(n)
int n;
{
int *vp;

   vp = (int *)malloc((unsigned) n*sizeof(int));
   if( !vp ) {
       fprintf(ERR,"memory allocation error\n");
       fprintf(ERR,"integer vector[%d]\n",n);
       exit(1);
     }
    return(vp);
}
char *cvector(n)
int n;
{
char *vp;

   vp = (char *)malloc((unsigned) n*sizeof(char));
   if( !vp ) {
       fprintf(ERR,"memory allocation error\n");
       fprintf(ERR,"char vector[%d]\n",n);
       exit(1);
     }
    return(vp);
}

double *dvector(n)
int n;
{
double *vp;

   vp = (double *)malloc((unsigned) n*sizeof(double));
   if( !vp ) {
       fprintf(ERR,"memory allocation error\n");
       fprintf(ERR,"double vector[%d]\n",n);
       exit(1);
     }
    return(vp);
}

int **imatrix(n1,n2)
int n1,n2;
{
int i,**ip;

 ip = (int **) malloc((unsigned ) n1*sizeof(int*) );
 if( !ip ) {
    fprintf(ERR,"memory allocation error\n");
    fprintf(ERR,"step1 integer matrix %d %d\n",n1,n2);
    exit(1);
  }
 for(i=0; i<n1 ; i++){
   ip[i] = (int *) malloc((unsigned) n2*sizeof(int));
   if( !ip[i] ) {
    fprintf(ERR,"memory allocation error\n");
    fprintf(ERR,"step2(i=%d) integer matrix %d %d\n",i,n1,n2);
    exit(1);

  }
 }
 
  return(ip);
				 
}




char **cmatrix(n1,n2)
int n1,n2;
{
int i;
char **ip;

 ip = (char **) malloc((unsigned ) n1*sizeof(char*) );
 if( !ip ) {
    fprintf(ERR,"memory allocation error\n");
    fprintf(ERR,"step1 char matrix %d %d\n",n1,n2);
    exit(1);
  }
 for(i=0; i<n1 ; i++){
   ip[i] = (char *) malloc((unsigned) n2*sizeof(char));
   if( !ip[i] ) {
    fprintf(ERR,"memory allocation error\n");
    fprintf(ERR,"step2(i=%d) integer matrix %d %d\n",i,n1,n2);
    exit(1);

  }
 }
 
  return(ip);
				 
}


double **dmatrix(n1,n2)
int n1,n2;
{
int i;
double **ip;

 ip = (double **) malloc((unsigned ) n1*sizeof(double*) );
 if( !ip ) {
    fprintf(ERR,"memory allocation error\n");
    fprintf(ERR,"step1 char matrix %d %d\n",n1,n2);
    exit(1);
  }
 for(i=0; i<n1 ; i++){
   ip[i] = (double *) malloc((unsigned) n2*sizeof(double));
   if( !ip[i] ) {
    fprintf(ERR,"memory allocation error\n");
    fprintf(ERR,"step2(i=%d) double matrix %d %d\n",i,n1,n2);
    exit(1);

  }
 }
 
  return(ip);
				 
}


Nodc **nvector(n)
int n;
{
int i;
Nodc **ip;

 ip = (Nodc **) malloc((unsigned ) n*sizeof(Nodc*) );
 if( !ip ) {
    fprintf(ERR,"memory allocation error\n");
    fprintf(ERR,"Nodc step1 %d\n",n);
    exit(1);
  }
 for(i=0; i<n ; i++){
   ip[i] = (Nodc *) malloc(sizeof(Nodc));
   if( !ip[i] ) {
    fprintf(ERR,"memory allocation error\n");
    fprintf(ERR,"step2(i=%d) Tnode %d\n",i,n);
    exit(1);

  }
 }
 
  return(ip);
				 
}


void free_ivector(v,n)
int *v,n;
{
   free((char*) v );
   return ;
 }

void free_dvector(v,n)
double *v;
int n;
{
   free((char*) v );
   return ;
 }


void free_cvector(v,n)
char *v;
int n;
{
   free((char*) v );
   return ;
 }


void free_cmatrix(m,n1,n2)
char **m;
int n1,n2;
{
int i;

    for(i=n1-1 ; i >= 0 ; i-- ){
       free((char *) (m[i]));
     }
    free((char *) m);
}

void free_imatrix(m,n1,n2)
int  **m;
int n1,n2;
{
int i;

    for(i=n1-1 ; i >= 0 ; i-- ){
       free((char *) (m[i]));
     }
    free((char *) m);
}


void free_dmatrix(m,n1,n2)
double  **m;
int n1,n2;
{
int i;

    for(i=n1-1 ; i >= 0 ; i-- ){
       free((char *) (m[i]));
     }
    free((char *) m);
}


void free_nvector(ip,n)
Nodc **ip;
int n;
{
int i;


 for(i=n-1; i=0 ; i--){
   free((char*) ip[i]);
 }
 free((char *)ip); 
  return ;
				 
}

checkfl(fpi,nseq,nsite,maxnm)
FILE *fpi;
int *nseq,*nsite,*maxnm;
{
int cw,flg,fc,sc,flg1,cw1;
/* flg  0   initial
        1   file name
        2   file name end
        3   sequence
   flg1 1   comment
 */

   *nseq=0;
   *nsite =0;
   *maxnm=0;
   fc=0;
   sc=0;
   flg1=0;
   flg = 0;
   cw =0;
   cw1=0;
   for( ; ; ){
      cw1=cw;
      if( cw1 != EOF ) cw = getc(fpi);
      if( cw1 == EOF ) break;
      if( cw1 == '/' && cw == '*' ){
          flg1 = 1;
          continue;
	}
      if( flg1 == 1 ) {
           if( cw1 == '*' && cw == '/' ){
               flg1=0;
	     }
            continue;
	 }
      switch(flg){
        case 0: if( cw1 == ' ' || cw1 == '\t' ) break;
                if( cw1 == '\n' ) break;
                flg=1;
                fc++;
                break;
        case 1: if( cw1 == ' ' || cw1 == '\t' ) {
                  if( fc > *maxnm ) *maxnm=fc;
                  fc=0;
                  flg = 2;
                  break;
		}
                if( cw1 == '\n' ){
                   fprintf(ERR,"format error (1) in data file\n");
                   exit(1);
		 }
                fc++;
                break;
        case 2: if( cw1 == ' ' || cw1 == '\t' ) break;
                if( cw1 == '\n' ){
                   fprintf(ERR,"format error (2) in data file\n");
                   exit(1);
		 }
                 flg=3;
                 sc++;
                 break;
         case 3: if( cw1 == '\n'){
                   if( *nseq == 0 ) {
                     *nsite = sc;
                   }else{
                     if( sc != *nsite ){
                        fprintf(ERR,"nsite is not the same %d (in seq %d)\n",sc,(*nseq)+1);
                        exit(1);                                                                    }
                   }
                   (*nseq)++;
                   flg=0;
                   sc=0;
                   fc=0;
                   break;
		 }
                 if( cw1 == ' ' || cw1 == '\t' ) break;
                 sc++;
	}
     
    }
    if( sc != 0 ){
      if( sc != *nsite ){
            fprintf(ERR,"nsite is not the same %d (in seq %d)\n",sc,(*nseq)+1);
            exit(1);                                                                    }
      (*nseq)++;
    }
    return(0);
}

rdseq(fpi,nseq,nsite,seq,seqnm,maxnm)
FILE *fpi;
int nseq,nsite,maxnm;
char **seq,**seqnm;
{
int i,cw,flg,fc,sc,flg1,cw1,seqc,sitec,cn;
/* flg  0   initial
        1   file name
        2   file name end
        3   sequence
   flg1 1   comment
 */
   cn=0;
   seqc=0;
   sitec=0;
   fc=0;
   sc=0;
   flg1=0;
   flg = 0;
   cw =0;
   cw1=0;
   for( ; ; ){
      cw1=cw;
      if( cw1 != EOF ) cw = getc(fpi);
      if( cw1 == EOF ) break;
      cn++;
      if( cn == 1 ) continue;
      if( cw1 == '/' && cw == '*' ){
          flg1 = 1;
          continue;
	}
      if( flg1 == 1 ) {
           if( cw1 == '*' && cw == '/' ){
               flg1=0;
	     }
            continue;
	 }
      

      switch(flg){
        case 0: if( cw1 == ' ' || cw1 == '\t' ) break;
                if( cw1 == '\n' ) break;
                flg=1;
                seqnm[seqc][fc]=cw1;
                fc++;
                if( fc > maxnm ) printf("fc=%d maxnm=%d seq %d\n",fc,maxnm,seqc);
                break;
        case 1: if( cw1 == ' ' || cw1 == '\t' ) {
                  fc=0;
                  flg = 2;
                  break;
		}
                if( cw1 == '\n' ){
                   fprintf(ERR,"format error (1) in data file\n");
                   exit(1);
		 }
                seqnm[seqc][fc]=cw1;
                fc++;
                if( fc > maxnm ) printf("fc=%d maxnm=%d seq %d\n",fc,maxnm,seqc);
                break;
        case 2: if( cw1 == ' ' || cw1 == '\t' ) break;
                if( cw1 == '\n' ){
                   fprintf(ERR,"format error (2) in data file\n");
                   exit(1);
		 }
                 flg=3;
                 seq[sc][seqc]=cw1;
                 sc++;
                 break;
         case 3: if( cw1 == '\n'){
                     if( sc != nsite ){
                        fprintf(stderr,"nsite is not the same %d (in seq %d)\n",sc,(seqc)+1);
                        exit(1);                                                                    }
                   seqc++;
                   if( seqc > nseq ) printf("seqc=%d nseq=%d\n",seqc,nseq);
                   flg=0;
                   sc=0;
                   fc=0;
                   break;
		   }
                 if( cw1 == ' ' || cw1 == '\t' ) break;
                 seq[sc][seqc]=cw1;
                 sc++;
                 break;
	default: break;
	}
     
    }
    if( sc != 0 ){
      if( sc != nsite ){
            fprintf(stderr,"nsite is not the same %d (in seq %d)\n",sc,seqc+1);
            exit(1);                                                                    }
      seqc++;
    }
   if( seqc != nseq ){
      printf("sequence number inconsistency seqc=%d nseq=%d\n",seqc,nseq);
      exit(1);
    }
   

/*   printf("rdseq seqc=%d\n",seqc); */
/*   for(i=0; i<nseq ; i++) printf("%d %s\n",i+1,seqnm[i]); */

    return(0);
}


njr(nseq,dist,node,branch0,otu,spair,sw,st,dcm,rij,seed1,accu)
int nseq,**node/*[MAXOTU-2][3]*/,*seed1;
int *otu/*[MAXOTU]*/,**spair/*[MAXOTU*(MAXOTU-1)/2][2]*/,*sw/*[MAXOTU*(MAXOTU-1)/2]*/;
double *st/*[MAXOTU*(MAXOTU-1)/2]*/,*dcm/*[MAXOTU]*/,*rij/*[MAXOTU]*/;
double **dist/*[MAXOTU][MAXOTU]*/,**branch0/*[MAXOTU][3]*/,accu;
{
int i,j,k,l,nsc,cyc,comb,tie,scnt,n1,n2,n3,nsm,nsw,rn;
double dw,s1,s2,s3,s,sm,ri,rj,ds;
double s12,s34,s56,s78;
float ran1();

  nsc=nseq;
  
  for(i=0; i<nseq-2 ; i++){
    for(j=0; j<3 ; j++) node[i][j]=0;
  }
  for(i=0; i<nseq; i++) otu[i]=i+1;
  for(cyc=0; cyc<nseq-3; cyc++){
     tie=0;
     scnt=0;
     ds=nsc-2;
     for(i=0; i<nsc ; i++){
        rij[i]=0.0;
        for(k=0; k<nsc ; k++){
             if( i < k ) rij[i] += dist[i][k];
             if( i > k ) rij[i] += dist[k][i];
         }
      }
     for(i=0; i<nsc-1; i++){
          for(j=i+1; j<nsc; j++){
          st[scnt]=dist[i][j]*ds-rij[i]-rij[j];
          spair[scnt][0]=i;
          spair[scnt][1]=j;
          if( scnt == 0 ) {
             sm=st[0];
             nsm = 0;
	   }else{
            if( st[scnt] < sm ){
               sm = st[scnt];
               nsm = scnt;
	     }
	  }
          scnt++;
	}
      }
      sw[0]=nsm;
      nsw=1;
      for(i=0; i<scnt ; i++){
         if( i == nsm ) continue;
         dw = st[i]-sm;
         if( dw < 0.0 ) dw *= -1.0;
         if( dw < accu ) {
           sw[nsw]=i;
           nsw++;
         }
       }
       if( nsw > 1 ){
/*          rn = random()%nsw; */
          rn = ran1(seed1)*(float)nsw;
          nsm = sw[rn];
	}
      n1=spair[nsm][0];
      n2=spair[nsm][1];
      node[cyc][0]=otu[n1];
      node[cyc][1]=otu[n2];
      dcm[cyc]=dist[n1][n2];
      branch0[cyc][0]=dist[n1][n2]/2.0+(rij[n1]-rij[n2])/(2.0*ds);
      branch0[cyc][1]=dist[n1][n2]/2.0+(rij[n2]-rij[n1])/(2.0*ds);
      if( otu[n1] > nseq ){
         n3=otu[n1]-nseq-1;
         branch0[cyc][0] -= dcm[n3]/2.0;
       }
      if( otu[n2] > nseq ){
         n3=otu[n2]-nseq-1;
         branch0[cyc][1] -= dcm[n3]/2.0;
       }
      for(k=0; k<nsc; k++) {
          if( k == n1 || k == n2 ) continue;
          if( n1 < k && n2 < k ) dist[n1][k] = (dist[n1][k] + dist[n2][k])/2.0;
          if( n1 < k && n2 > k ) dist[n1][k] = (dist[n1][k] + dist[k][n2])/2.0;
          if( n1 > k && n2 < k ) dist[k][n1] = (dist[k][n1] + dist[n2][k])/2.0;
          if( n1 > k && n2 > k ) dist[k][n1] = (dist[k][n1] + dist[k][n2])/2.0;
	}
      otu[n1]=nseq+cyc+1;
      for(k=n2; k<nsc-1; k++) otu[k]=otu[k+1];

      for(k=0; k< n2 ; k++){
         for(l=n2+1 ; l< nsc ; l++)  dist[k][l-1] = dist[k][l];
       }
       for(k=n2+1 ; k<nsc-1 ; k++){
         for(l=k+1 ; l<nsc ; l++) dist[k-1][l-1] =dist[k][l];
       }

   
     

/*      for(k=0; k<nsc ; k++){
        for(l=n2; l<nsc-1; l++){
           dist[k][l] =dist[k][l+1];
	 }
       }
      for(k=0; k<nsc ; k++){
         for(l=n2; l<nsc-1 ; l++){
           dist[l][k] =dist[l+1][k];
         }
       }
*/
       nsc--;
   
}

cyc=nseq-3;
 branch0[cyc][0]=(dist[0][1]+dist[0][2]-dist[1][2])/2.0;
 branch0[cyc][1]=(dist[0][1]-dist[0][2]+dist[1][2])/2.0;
 branch0[cyc][2]=(-dist[0][1]+dist[0][2]+dist[1][2])/2.0;
 for(i=0; i<3 ; i++){
   node[cyc][i]=otu[i];
   if( otu[i] > nseq ){
         n3=otu[i]-nseq-1;
         branch0[cyc][i] -= dcm[n3]/2.0;
       }
 }

 return(0);
}
           


njt(nseq,dist,node,branch0,otu,spair,sw,st,dcm,rij)
int nseq,**node/*[MAXOTU-2][3]*/;
int *otu/*[MAXOTU]*/,**spair/*[MAXOTU*(MAXOTU-1)/2][2]*/,*sw/*[MAXOTU*(MAXOTU-1)/2]*/;
double *st/*[MAXOTU*(MAXOTU-1)/2]*/,*dcm/*[MAXOTU]*/,*rij/*[MAXOTU]*/;
double **dist/*[MAXOTU][MAXOTU]*/,**branch0/*[MAXOTU][3]*/;
{
int i,j,k,l,nsc,cyc,comb,scnt,n1,n2,n3,nsm,nsw,rn;
double dw,s1,s2,s3,s,sm,ri,rj,ds;
double s12,s34,s56,s78;
  nsc=nseq;
  
  for(i=0; i<nseq-2 ; i++){
    for(j=0; j<3 ; j++) node[i][j]=0;
  }
  for(i=0; i<nseq; i++) otu[i]=i+1;
  for(cyc=0; cyc<nseq-3; cyc++){
     scnt=0;
     ds=nsc-2;
     for(i=0; i<nsc ; i++){
        rij[i]=0.0;
        for(k=0; k<nsc ; k++){
             if( i < k ) rij[i] += dist[i][k];
             if( i > k ) rij[i] += dist[k][i];
         }
      }
     for(i=0; i<nsc-1; i++){
          for(j=i+1; j<nsc; j++){
          st[scnt]=dist[i][j]*ds-rij[i]-rij[j];
          spair[scnt][0]=i;
          spair[scnt][1]=j;
          if( scnt == 0 ) {
             sm=st[0];
             nsm = 0;
	   }else{
            if( st[scnt] < sm ){
               sm = st[scnt];
               nsm = scnt;
	     }
	  }
          scnt++;
	}
      }
/*
      sw[0]=nsm;
      nsw=1;
      for(i=0; i<scnt ; i++){
         if( i == nsm ) continue;
         dw = st[i]-sm;
         if( dw < 0.0 ) dw *= -1.0;
         if( dw <= ACU ) {
           sw[nsw]=i;
           nsw++;
         }
       }
       if( nsw > 1 ){
          rn = random()%nsw;
          nsm = sw[rn];
	}
*/
      n1=spair[nsm][0];
      n2=spair[nsm][1];
      node[cyc][0]=otu[n1];
      node[cyc][1]=otu[n2];
      dcm[cyc]=dist[n1][n2];
      branch0[cyc][0]=dist[n1][n2]/2.0+(rij[n1]-rij[n2])/(2.0*ds);
      branch0[cyc][1]=dist[n1][n2]/2.0+(rij[n2]-rij[n1])/(2.0*ds);
      if( otu[n1] > nseq ){
         n3=otu[n1]-nseq-1;
         branch0[cyc][0] -= dcm[n3]/2.0;
       }
      if( otu[n2] > nseq ){
         n3=otu[n2]-nseq-1;
         branch0[cyc][1] -= dcm[n3]/2.0;
       }
      for(k=0; k<nsc; k++) {
          if( k == n1 || k == n2 ) continue;
          if( n1 < k && n2 < k ) dist[n1][k] = (dist[n1][k] + dist[n2][k])/2.0;
          if( n1 < k && n2 > k ) dist[n1][k] = (dist[n1][k] + dist[k][n2])/2.0;
          if( n1 > k && n2 < k ) dist[k][n1] = (dist[k][n1] + dist[n2][k])/2.0;
          if( n1 > k && n2 > k ) dist[k][n1] = (dist[k][n1] + dist[k][n2])/2.0;
	}
      otu[n1]=nseq+cyc+1;
      for(k=n2; k<nsc-1; k++) otu[k]=otu[k+1];

      for(k=0; k< n2 ; k++){
         for(l=n2+1 ; l< nsc ; l++)  dist[k][l-1] = dist[k][l];
       }
       for(k=n2+1 ; k<nsc-1 ; k++){
         for(l=k+1 ; l<nsc ; l++) dist[k-1][l-1] =dist[k][l];
       }

   
     

/*      for(k=0; k<nsc ; k++){
        for(l=n2; l<nsc-1; l++){
           dist[k][l] =dist[k][l+1];
	 }
       }
      for(k=0; k<nsc ; k++){
         for(l=n2; l<nsc-1 ; l++){
           dist[l][k] =dist[l+1][k];
         }
       }
*/
       nsc--;
   
}

cyc=nseq-3;
 branch0[cyc][0]=(dist[0][1]+dist[0][2]-dist[1][2])/2.0;
 branch0[cyc][1]=(dist[0][1]-dist[0][2]+dist[1][2])/2.0;
 branch0[cyc][2]=(-dist[0][1]+dist[0][2]+dist[1][2])/2.0;
 for(i=0; i<3 ; i++){
   node[cyc][i]=otu[i];
   if( otu[i] > nseq ){
         n3=otu[i]-nseq-1;
         branch0[cyc][i] -= dcm[n3]/2.0;
       }
 }

 return(0);
}
           

/* distance caluculation routines */
gmadis(dd,ntt,nts,ntv,gammaa)
double *dd,gammaa;
int ntt,nts,ntv;
{
double dp,dq,dc1,dc2,dnt,dw1,dw2;
double pow(),sqrt();
dnt=ntt;
dp=nts;
dp /= dnt;
dq = ntv;
dq /= dnt;

dw1 = pow(1.0-2.0*dp-dq,-1.0/gammaa);
dw2 = pow(1.0-2.0*dq,-1.0/gammaa);
*dd = gammaa*0.5*(dw1+0.5*dw2-1.5);
printf("gamma=%f %d %d %d\n",gammaa,ntt,nts,ntv);
return(0);
}


/* Tamura (3) diatance */
tm3dis(dd,cnh,ntt,nts,ntv)
double *dd;
int cnh[4][4],ntt,nts,ntv;
{
int i,j,ngc;
double p,q,dw,theta; /* theta: GC-content */
double da,db,dt,ds,dv,dl1,dl2;
double log(),sqrt();
dt=ntt;
ds=nts;
dv=ntv;
p=ds/dt;
q=dv/dt;

ngc=0;
for(i=0; i<4; i++){
  for(j=0; j<4 ; j++){
     if( i == 2 ) ngc += cnh[i][j];
     if( i == 3 ) ngc += cnh[i][j];
     if( j == 2 ) ngc += cnh[i][j];
     if( j == 3 ) ngc += cnh[i][j];
   }
}
theta = ngc;
theta /= 2.0*ntt;
dl1 = log(1.0-p/(2.0*theta*(1.0-theta))- q);
dl2= log(1.0-2.0*q);
*dd = -2.0*theta*(1.0-theta)*dl1-(1.0-2.0*theta*(1.0-theta))*dl2/2.0;
 return(0);
}      



/* calculate Tajima-Nei distance */
tndis(dd,cnh,ntt,ndif)
double *dd;
int cnh[4][4],ntt,ndif;
{
int i,j,nt,g[4];
double log(),sqrt(), dw,dg[4],dnt,dc,db,dp,dt,dvar;

dt=ntt;
dp=ndif;
dp /= dt;
if( ndif == 0 ){
     *dd=0.0;
     return(0);
   }
/* printf("dp=%f ",dp); */
for(i=0; i<4; i++) g[i]=0;
nt=0;
for(i=0; i<4; i++){
 for(j=0; j<4 ; j++){
    g[i] += cnh[i][j];
    g[j] += cnh[i][j];
    nt += 2*cnh[i][j];
  }
}

dnt = nt;
for(i=0; i<4; i++){
  dg[i] = g[i];
  dg[i] /= dnt;
/* printf("g[%d]=%f nt=%d",i,dg[i],nt);  */
}

/* printf("gt=%f\n g=%d",dg[0]+dg[1]+dg[2]+dg[3],g[0]+g[1]+g[2]+g[3]); */
dc=0.0;
for(i=0; i<3; i++){
  for(j=i+1; j<4 ; j++){
     if( cnh[i][j]+cnh[j][i] == 0 ) continue;
     dw = cnh[i][j]+cnh[j][i];
     dw /= dt;
/*     printf("%c%c x=%f ",base[i],base[j],dw); */
     dc += dw*dw/(2.0*dg[i]*dg[j]);
   }
}
db = 1.0+dp*dp/dc;
for(i=0; i<4; i++) db -= dg[i]*dg[i];
db /= 2.0;
if( 1.0 - dp/db <= 0.0 ) return(-1);
*dd = -db*log(1.0 - dp/db);

return(0);
}
/* calculate Jukes-Cantor distance */
int jcdis(dd,nt,nd)
double *dd;
int nd,nt;
{
double dn,dp,dva,log(),sqrt();
dn = nt;
dp  = nd;
dp /= dn;
if( 1.0-dp*4.0/3.0 <= 0.0 ) return(-1);
*dd = log(1.0-dp*4.0/3.0);
*dd *= -0.75;
/* printf("dd=%f dp=%f\n",*dd,dp); */
return(0);
}
/* calculate Kimura's two parameter distance */

int k2pdis(dd,nt,ns,nv)
double *dd;
int nt,ns,nv;
{
double dt,dn, da,db,dp,dq,log(),sqrt(),dva,dsq;
dp = ns;
dq = nv;
dt = nt;
dp /= dt;
dq /= dt;
/* printf("nt=%d ns=%d nv=%d\n",nt,ns,nv); */
if( 1.0 - 2.0*dq <= 0.0 ) return(-1);
if( 1.0-2.0*dp-dq <= 0.0 ) return(-1);
dsq = sqrt(1.0- 2.0*dq);
*dd = log((1.0-2.0*dp-dq)*dsq);

*dd *= -0.5;
return(0);
}



njtndp(nseq,node,nodes,ncn)
int nseq,**node/*[MAXOTU-1][3]*/;
Nodc **nodes/*[MAXOTU-2]*/;
char *ncn/*[MAXOTU-2]*/;
{
int i,j,k,nc,flg;


for(i=0; i<nseq-2 ; i++){
   nc=2;
   ncn[i]=0;
   if( i == nseq-3 ) nc=3;
   for(j=0; j<nc ; j++) {
      if( node[i][j] <= nseq ){
          nodes[i]->childn[j]=node[i][j];
          nodes[i]->childio[j]= 0;
          continue;
	}
        nodes[i]->childn[j]=node[i][j]-nseq;
        nodes[i]->childio[j]= 1;
    }
}
for(i=0; i<nseq-3; i++){
  flg =0;
  for(j=0; j<nseq-2; j++){
    if( i == j ) continue;
    nc=2;
    if( j == nseq-3 ) nc=3;
    for(k=0; k<nc ; k++){
      if( node[j][k] == i+nseq+1 ) {
        flg =1;
        nodes[i]->childn[2]=j+1;
        nodes[i]->childio[2]= 1;
        break;
      }
    }
    if( flg == 1) break;
  }
}

if( dflg == 2){
   for(i=0; i<nseq-2 ; i++){
     printf("nodes %d:",i);
     for(j=0;j<3 ; j++) printf("%d %d  ",nodes[i]->childio[j],nodes[i]->childn[j]);
     printf("\n");
   }
 }

if( dflg == 2){
   for(i=0; i<nseq-2 ; i++){
     printf("nodes %d:",i);
     for(j=0;j<3 ; j++) printf("%d %d  ",nodes[i]->childio[j],nodes[i]->childn[j]);
     printf("\n");
   }
 }
return(0);
}


parti(nseq,nodes,part,bri,rlo,rli,chf)
int nseq,**bri/*[MAXOTU-3][2]*/;
Nodc **nodes/*[MAXOTU-2]*/;
char **part/*[MAXOTU-3][MAXOTU]*/,*rlo,*rli,*chf;
{
int i,j,k,nb,flg,iw;
int nbri,nr,nl,or,ol,ns;
/* char rlo[MAXOTU],rli[MAXOTU-2],chf[MAXOTU-2];*/

/* printf("parti start nseq=%d\n",nseq);  */
nbri=0;
for(i=0; i<nseq-2; i++){
  for(j=0; j<3 ; j++) {
    if(  nodes[i]->childio[j] ==  1 && nodes[i]->childn[j] < i+1 ){
         bri[nbri][0]= nodes[i]->childn[j];
         bri[nbri][1]= i+1;
/*         printf("%d   %d %d\n",nbri,bri[nbri][0],bri[nbri][1]);  */
         nbri++;
       }
  }
}
/*  for(i=0; i<nseq-2; i++) printf("node %d  %d (%d) %d (%d) %d (%d)\n",i,nodes[i].childn[0],nodes[i].childio[0],nodes[i].childn[1],nodes[i].childio[1],nodes[i].childn[2],nodes[i].childio[2]);
    }
*/
if( nbri != nseq-3 ){
    printf("number of internal branches invalid %d\n",nbri);
    exit(1);
  }

for(nb=0; nb < nbri ; nb++){
   for(i=0; i<nseq-2 ; i++){
        chf[i]=0;
        rli[i]=' ';
      }
   for(i=0; i<nseq ; i++) {
     rlo[i]=' ';
     part[nb][i]=0;
   }
   or=bri[nb][0];
   ol=bri[nb][1];
   nr=0;
   nl=0;
   for(i=0; i<3 ; i++){
      if( nodes[or-1]->childio[i] == 1 && nodes[or-1]->childn[i] == ol ) continue;
      switch(nodes[or-1]->childio[i] ){
          case 1:  iw = nodes[or-1]->childn[i]-1; rli[iw]='r';
                   break;
          case 0 : iw = nodes[or-1]->childn[i]-1;
                   rlo[iw]='r';
                   nr++;
                   break;
	}
    }
   for(i=0; i<3 ; i++){
      if( nodes[ol-1]->childio[i] == 1 && nodes[ol-1]->childn[i] == or ) continue;
      switch(nodes[ol-1]->childio[i]){
          case 1 :  iw = nodes[ol-1]->childn[i]-1;
                    rli[iw]='l';
                    break;
          case 0 :  iw = nodes[ol-1]->childn[i]-1;rlo[iw]='l';
                    nl++;
                    break;
	}
    }
    chf[or-1]=1;
    chf[ol-1]=1;
    ns=2;
  for( ; ; ){
    for(i=0; i< nseq-2 ; i++){
/*
      printf("i=%d nseq=%d nb=%d ns=%d\n",i,nseq,nb,ns); 
      printf("chf ");
      for(j=0; j< nseq-2 ; j++) printf(" %d",chf[j]);
      printf("\n");
      printf("rli ");
      for(j=0; j< nseq-2 ; j++) printf(" %c",rli[j]);
      printf("\n");
      printf("rlo ");
      for(j=0; j< nseq ; j++) printf(" %c",rlo[j]);
      printf("\n");
*/
      if( ns >= nseq-2 && nseq == 4 ) goto S1;
      if( chf[i] == 1 ) continue;
      if( rli[i] == ' '  ) continue; 
      switch( rli[i] ){
         case  'r':
                   for(j=0; j<3 ; j++){
                     iw = nodes[i]->childn[j]-1;
                     if( nodes[i]->childio[j] == 1 && rli[iw] == 'r' )
 continue;
                     switch(nodes[i]->childio[j]) {
                       case 1 : iw = nodes[i]->childn[j]-1; rli[iw]='r';
                                break;
                       case 0 : iw = nodes[i]->childn[j]-1;
                                rlo[iw]='r';
                                nr++;
                                break;
		     }
		   }
                    ns++;
/*                    printf("ns=%d nseq=%d (1)\n",ns,nseq);*/
                    if( ns >= nseq-2 ) goto S1;
                    break;
        case  'l' :
           for(j=0; j<3 ; j++){
             iw = nodes[i]->childn[j]-1;
             if( nodes[i]->childio[j] == 1 && rli[iw] == 'l' )
continue;
             switch( nodes[i]->childio[j]) {
                 case 1 : iw = nodes[i]->childn[j]-1; rli[iw]='l';
                          break;
                 case 0 : iw = nodes[i]->childn[j]-1;
                          rlo[iw]='l';
                          nl++;
		  }
	   }
           ns++;
/*           printf("ns=%d nseq=%d (2)\n",ns,nseq); */
           if( ns >= nseq-2 ) goto S1;
           break;
		 }
        chf[i]=1;
    }
  }
S1:    if( nl+nr != nseq ) {
      printf("nl=%d nr=%d nseq=%d\n",nl,nr,nseq);
      exit(1);
    }
/*     printf("nl=%d nr=%d nseq=%d\n",nl,nr,nseq); */
   
    if( nl < nr ){
        for(i=0; i<nseq ; i++){
          if( rlo[i] == 'l' ) part[nb][i]=1;
        }
      }
    if( nl >= nr ){
        for(i=0; i<nseq ; i++){
          if( rlo[i] == 'r' ) part[nb][i]=1;
        }
      }
/*
    printf("rlo:");
    for(i=0; i<nseq ; i++){
      printf(" %c",rlo[i]);
    }
    printf("\n");
    printf("part:");
    for(i=0; i<nseq ; i++){
      printf(" %d",part[nb][i]);
    }
    printf("\n");
*/

  
 }

  
if( dflg == 1 ) {
   for(i=0; i<nseq-3 ; i++){
     for(j=0; j<nseq ; j++){
        printf(" %d",part[i][j]);
      }
     printf("\n");
   }
 }
/*  printf("parti return\n");  */
return(0);
}


ressite(nasite,asite,rsite,psite,npsite,sitef,seed1,dop)
int nasite, *asite,*rsite,*psite,*npsite,*sitef,*seed1,dop;
{
int i,rn;
float ran1();

*npsite=0;
for(i=0; i<nasite ; i++){
/*   rn=random()%nasite; */
  rn = ran1(seed1)*(float)nasite;
  if( rn < 0 ) rn = 0;
  if( rn >= nasite ) rn = nasite-1;
   rsite[i]=asite[rn];
   if( sitef[asite[rn]] == 2 ){
       psite[*npsite]=rn;
       (*npsite)++;
     }
/*   printf("i=%d rn=%d asite[%d]=%d\n",i,rn,rn,asite[rn]); */
 }
/* printf("\n"); */
return(0);
}

caldist(nseq,a,fl,nasite,rsite,npsite,psite,dist,dop,fpo,gamma,bootflg,pairwiseflg,sitef,cdn,pflg,maxnm)
FILE *fpo;
char **a/*[MAXSITE][MAXOTU]*/,**fl/*[MAXOTU][MAXNM]*/;
int nasite, *rsite,dop,npsite,*psite,bootflg,pairwiseflg,*sitef,cdn[4][4][4],pflg,maxnm;
double **dist/*[MAXOTU][MAXOTU]*/,gamma;
{
int rn,i,j,k,l,l1,cnch[4][4],cw,b1,b2,nts,ntv,nid,ndf,nts1,nts2,nb[5],na,nt;
int naf[20],nafp[20][20];
double dp,ga,gt,gg,gc,gr,gy,dw1,dw2,dw3,dp1,dp2,dw,dq,max=0.00,dx,db,dc;
double daf[20];


if( dop >= 18 && dop <= 21 ){
  /*    printf("dop=%d\n",dop); fflush(stdout);*/
    rn=calsyn(nseq,a,fl,nasite,rsite,dist,dop,fpo,bootflg,pairwiseflg,sitef,cdn,pflg,maxnm);
    if( rn != 0 ) return(-1);
    return(0);
}

if( dop == 10 || dop == 11  || dop == 17){
  for(i=0; i<nseq-1 ; i++){
    for(j=i+1; j<nseq ; j++){
        nts1=0;nts2=0;ntv=0;
        nid=0;ndf=0;
         for(k=0; k<npsite ; k++){
            b1= a[psite[k]][i];
            b2= a[psite[k]][j];
            if( b1 >= 5 || b2 >= 5 ) continue;
            switch(trp[b1][b2]){
               case -1: nid++;
                        break;
               case 0 : ndf++;
                        break;
          }
        }
        if( nid+ndf == 0 ) return(-10);
        dist[i][j] = ndf;
/*         printf(" %4d",ndf); */
        if( dop == 17 ) continue;
        dist[i][j] /= nasite;
        dist[j][i] = dist[i][j];
/*        printf("%d %d %f\n",i,j,dist[i][j]); */
      }
/*      printf("\n"); */
  }
  return(0); 
}




if( dop == 5 || dop == 6 || dop == 7 ){
  for(i=0; i<nseq-1 ; i++){
    for(j=i+1; j<nseq ; j++){
        ndf=0;
        nid=0;
         for(k=0; k<npsite ; k++){
            b1= a[psite[k]][i];
            b2= a[psite[k]][j];
            if( b1 >= 20 || b2 >= 20 ) continue;
            if( b1 == b2 ) nid++;
            if( b1 != b2 ) ndf++;
        }
        if( nid+ndf == 0 ) return(-10);
        switch(dop){
           case 6: dist[i][j] = ndf;
                   dist[i][j] /= nasite;
                   dist[j][i] = dist[i][j];
                   break;
           case 5: dp = ndf;
                   dp /= nasite;
                   if( 1.0-dp/0.95 <= 0.0 ){
                      if( bootflg == 0 ) printf("inapplicable %d %d\n",i,j);
                      return(-1);
		    }
                   dist[i][j] = -0.95*log(1.0-dp/0.95);
                   dist[j][i] = dist[i][j];
                   break;
           case 7: dp = ndf;
                   dp /= nasite;
                   if( 1.0-dp/0.95 <= 0.0 ){
                      if( bootflg == 0 ) printf("inapplicable %d %d\n",i,j);
                      return(-1);
		    }
                   dw = 1.0-dp/0.95;
                   
                   dist[i][j] = 0.95*gamma*(pow(dw,-1.0/gamma)-1.0);
                   dist[j][i] = dist[i][j];
                   break;
	
	   }

      }
  }
  return(0);
}

if( dop == 22 ){
  for(i=0; i<nseq-1 ; i++){
    for(j=i+1; j<nseq ; j++){
        for(k=0; k<20 ; k++) {
          naf[k]=0;
          for(l=0; l<20 ; l++) nafp[k][l]=0;
	}
        ndf=0;
        nid=0;
         for(k=0; k<nasite ; k++){
            b1= a[rsite[k]][i];
            b2= a[rsite[k]][j];
            naf[b1]++;
            naf[b2]++;
            nafp[b1][b2]++;
            if( b1 >= 20 || b2 >= 20 ) continue;
            if( b1 == b2 ) nid++;
            if( b1 != b2 ) ndf++;
        }
        if( nid+ndf == 0 ) return(-10);
           dp = ndf;
           dp /= nasite;
           dc = 0.;
           for(k=0; k<20 ; k++){
             daf[k] = naf[k];
             daf[k] /= 2*nasite;
	     /*             printf(" %f",daf[k]);*/
	   }
           for(k=0; k<19 ; k++){
	     for(l=k+1; l<20 ; l++){
                if( nafp[k][l]+nafp[l][k] == 0 ) continue;
                dx = nafp[k][l]+nafp[l][k];
                dx /= nasite;
                dc += dx*dx/(2.*daf[k]*daf[l]);
	     }
	   }
           db=0.;
           for(k=0; k<20 ; k++){
            db += daf[k]*daf[k];
	   }
           db *= -1.0;
           db += 1.0 + dp*dp/dc;
           db /= 2.;
	   /* printf("db=%f\n",db);*/
           if( 1. - dp/db < ACU ) return(-10);
           dist[i][j] = -db*log(1.-dp/db);
           dist[j][i] = dist[i][j];
	}
  }
 return(0);
}


if( dop == 8 || dop == 9  || dop == 15 || dop == 16 ){
  for(i=0; i<nseq-1 ; i++){
    for(j=i+1; j<nseq ; j++){
/*         printf("i=%d j=%d\n",i,j); */
         nts1=nts2=ntv=0;
         nid=0;
         nb[0]=nb[1]=nb[2]=nb[3]=nb[4]=0;
         for(k=0; k<nasite ; k++){
            b1= a[rsite[k]][i];
            b2= a[rsite[k]][j];
            if( b1 >= 4 ) continue;
            if( b2 >= 4 ) continue;
            nb[b1]++;
            nb[b2]++;
            switch(tr1[b1][b2]){
         	    case 0:   nid++;
                              break;
         	    case 1:   nts1++;
                              break;
         	    case 2:   nts2++;
                              break;
         	    case 3:   ntv++;
                              break;
		    }

        }
/*        printf("i=%d j=%d nid=%d nts1=%d nts2=%d ntv=%d \n",i,j,nid,nts1,nts2,ntv);  */
        if( nid+nts1+nts2+ntv == 0 ) return(-10);
        nt = nasite;
        na = (nid+nts1+nts2+ntv)*2;
        ga = nb[0];
        ga /= na;
        gt = nb[1];
        gt /= na;
        gg = nb[2];
        gg /= na;
        gc = nb[3];
        gc /= na;
        gr = ga + gg;
        gy = gt + gc;
        dp1 = nts1;
        dp2 = nts2;
        dq  = ntv;
        dp1 /= nt;
        dp2 /= nt;
        dq  /= nt;
        if( nts1+nts2+ntv == 0 ) {
            dist[i][j]=0.0;
            continue;
	  }
        dw1 = 1.0 - gr*dp1/(2.0*ga*gg) - dq/(2.0*gr);
        dw2 = 1.0 - gy*dp2/(2.0*gt*gc) - dq/(2.0*gy);
        dw3 = 1.0- dq/(2.0*gr*gy);

/*        printf("a t g c %f %f %f %f dw %f %f %f\n",ga,gt,gg,gc,dw1,dw2,dw3); */
        if( dop == 8 || dop == 9 ) if( 1.0 - gr*dp1/(2.0*ga*gg) - dq/(2.0*gr) <= 0.0 ) {
           if( bootflg == 0 ) printf("inapplicable %d %d\n",i,j);
           return(-1);
	 }
        if( dop == 8 || dop == 9 ) if( 1.0 - gy*dp2/(2.0*gt*gc) - dq/(2.0*gy) <=0.0 ) {
                    if( bootflg == 0 ) printf("inapplicable %d %d\n",i,j);
                    return(-1);
		  }
        if( 1.0- dq/(2.0*gr*gy) <= 0.0 ) {
           if( bootflg == 0 ) printf("inapplicable %d %d\n",i,j);
             return(-1);
	 }
        switch(dop){
           case 8: dist[i][j]= ga*gg/(gr)*log(dw1) + gt*gc/(gy)*log(dw2) + (gr*gy-ga*gg*gy/gr - gt*gc*gr/gy)*log(dw3);
                   dist[i][j] *= -2.0;
                   dist[j][i] = dist[i][j];
                   break;
           case 9:  dist[i][j] = ga*gg/(gr)*pow(dw1,-1.0/gamma)+gt*gc/gy*pow(dw2,-1.0/gamma)+(gr*gy-ga*gg*gy/gr-gt*gc*gr/gy)*pow(dw3,-1.0/gamma) -ga*gg-gt*gc-gr*gy;
                   dist[i][j] *= 2.0*gamma;
                   dist[j][i] = dist[i][j];
/*                   printf("gamma=%f %d %d %f\n",gamma,i,j,dist[i][j]); */
                   break;

           case 15:  dist[i][j] = -2.0*gr*gy*log(1.0-dq/(2.0*gr*gy));
                     dist[j][i] = dist[i][j];
                     break;
           case 16:  dist[i][j] = pow(1.0-dq/(2.0*gr*gy),-1.0/gamma)-1.0;
                     dist[i][j] *= 2.0*gamma*gr*gy;
                     dist[j][i] = dist[i][j];

                   break;
                   

	   }

      }
  }
/*  printf("max=%f\n",max); */
  return(0);
}

if( dop == 2 || dop == 3 ){
        
for(i=0; i<nseq-1 ; i++){
  for(j=i+1; j<nseq ; j++){
    for(k=0; k<4; k++){
      for(l=0; l<4 ; l++){
          cnch[k][l]=0;
      }
    }
   nts=0;
   ntv=0;
   nid=0;
    for(k=0; k<nasite ; k++){
          b1= a[rsite[k]][i];
          b2= a[rsite[k]][j];
          if( b1 >= 4 ) continue;
          if( b2 >= 4 ) continue;
          switch(tr[b1][b2]){
               case -1: nid++;
                        break;
               case 0 : nts++;
                        break;
                case 1: ntv++;
                        break;
          }
          cnch[b1][b2]++; 

     }
     if(  nid + nts+ntv == 0 ) return(-10);
/*    printf("%d %s  %d %s   %d %d %d\n",i,fl[i],j,fl[j],nid+nts+ntv,nts,ntv);*/
    rn=caldis(cnch,i,j,fl,fpo,dist,dop,nid,nts,ntv,nasite,gamma);
    dist[j][i] = dist[i][j];
   if( rn != 0  ) return(rn);
  }
}
  return(0);

}

/*  printf("chkseq end\n"); */
for(i=0; i<nseq-1 ; i++){
  for(j=i+1; j<nseq ; j++){
   nts=0;
   ntv=0;
   nid=0;
    for(k=0; k<npsite ; k++){
          b1= a[psite[k]][i];
          b2= a[psite[k]][j];
          if( b1 >= 4 ) continue;
          if( b2 >= 4 ) continue;
          switch(tr[b1][b2]){
               case -1: nid++;
                        break;
               case 0 : nts++;
                        break;
                case 1: ntv++;
                        break;
          }
     }
     if(  nid + nts+ntv == 0 ) return(-10);
/*    printf("%d %s  %d %s   %d %d %d\n",i,fl[i],j,fl[j],nid+nts+ntv,nts,ntv);*/
    rn=caldis(cnch,i,j,fl,fpo,dist,dop,nid,nts,ntv,nasite,gamma);
    dist[j][i] = dist[i][j];
   if( rn != 0  ) return(rn);
  }
}



return(0);
}

caldis(cnch,s1,s2,fl,fpo,dist,dop,nid,nts,ntv,nasite,gammaa)
int cnch[4][4],s1,s2,dop,nid,nts,ntv,nasite;
char **fl/*[MAXOTU][20]*/;
FILE *fpo;
double **dist/*[MAXOTU][MAXOTU]*/,gammaa;
{
int rn,i,j,k;
double dda[2],dq;



/*  if( nts + ntv == 0  ) return(-2); */
  switch(dop){
   case 0:  
            rn=jcdis(&dda[0],nasite,nts+ntv);
            if( rn != 0 ) return(-1);
            dist[s1][s2]= dda[0];
            break;
   case 1:   rn=k2pdis(&dda[0],nasite,nts,ntv);
             if( rn != 0 ) return(-1);
             dist[s1][s2]= dda[0];
             break;
   case 2 :   rn=tndis(&dda[0],cnch,nid+nts+ntv,nts+ntv);
             if( rn != 0 ) return(-1);
             dist[s1][s2]= dda[0];
             break;
   case 3 :   rn=tm3dis(&dda[0],cnch,nid+nts+ntv,nts,ntv);
             if( rn != 0 ) return(-1);
             dist[s1][s2]= dda[0];
             break;
   case 4 :   
             rn=gmadis(&dda[0],nasite,nts,ntv,gammaa);
/*             printf("gamma %f %f\n",gammaa,dda[0]); */
             if( rn != 0 ) return(-1);
             dist[s1][s2]=dda[0];
             break;
   case 12 : dist[s1][s2] = ntv;
             dist[s1][s2] /= nasite;
             break;

   case 13 : dq = ntv;
             dq /= nasite;
             if( 1.0 - 2.0*dq <= 0.0 ) return(-1);
             dist[s1][s2] = -0.25*log(1.0-2.0*dq);
             break;

   case 14 : dq = ntv;
             dq /= nasite;
             if( 1.0 - 2.0*dq <= 0.0 ) return(-1);
             dist[s1][s2] = pow(1.0-2.0*dq,-1.0/gammaa)-1.0;
             dist[s1][s2] *= 0.25*gammaa;
             break;



   }


  return(0);
}
caldpro(nseq,a,fl,nasite,rsite,dist,fpo)
FILE *fpo;
char **a/*[MAXSITE][MAXOTU]*/,**fl/*[MAXOTU][MAXNM]*/;
int nasite, *rsite;
double **dist/*[MAXOTU][MAXOTU]*/;
{
int rn,i,j,k,l,l1,cw,b1,b2,nts,ntv,nid,ndf;


  for(i=0; i<nseq-1 ; i++){
    for(j=i+1; j<nseq ; j++){
        ndf=0;
        nid=0;
         for(k=0; k<nasite ; k++){
            b1= a[rsite[k]][i];
            b2= a[rsite[k]][j];
            if( b1 !=  b2  ) ndf++;
            if( b1 ==  b2  ) nid++;

        }
        if( nid+ndf != nasite ) return(-10);
        dist[i][j] = nid;
        dist[i][j] /= nasite;
        dist[i][j] = -log(dist[i][j]);
/*        printf("%d-%d nid=%d nasite=%d  %f\n",i,j,nid,nasite,dist[i][j]); */
      }

  }
        
return(0);
}



cpart(nseq,part,partb,npart,pb,npw,bw,pw1,pw2)
int nseq, *npart;
int *pb,*npw,*bw;
char *pw1,*pw2;
char **part/*[MAXOTU-3][MAXOTU]*/,**partb/*[MAXOTU-3][MAXOTU]*/;
{
int i,j,k,np,ncf1,ncf2,nb;

np=nseq-3;
/*
printf("part\n");
for(i=0; i<np ; i++){
  for(j=0; j<nseq ; j++) printf(" %d",part[i][j]);
  printf("\n");
}
printf("partb\n");
for(i=0; i<np ; i++){
  for(j=0; j<nseq ; j++) printf(" %d",partb[i][j]);
  printf("\n");
}
*/
for(i=0; i<np ; i++) bw[i]=i;
nb = np;
for(i=0; i<np ; i++){
  for(j=0; j<nseq ; j++){
     pw1[j]=part[i][j];
     switch(part[i][j]){
       case 0 : pw2[j]=1;
                break;
       case 1 : pw2[j]=0;
                break;
       }
   }
       for(j=0; j<nb ; j++){
           ncf1=0;
           ncf2=0;
          for(k=0; k<nseq ; k++){
             if( pw1[k] != partb[bw[j]][k] ) {
                ncf1=1;
                break;
	      }
           }
          if( ncf1 == 0 ) {
             npart[i]++;
             for(k=j; k<nb-1 ; k++) bw[k]=bw[k+1];
             nb--;
             break;
	   }
          for(k=0; k<nseq ; k++){
             if( pw2[k] != partb[bw[j]][k] ) {
                ncf2=1;
                break;
	      }
           }
        
          if( ncf2 == 0 ) {
             npart[i]++;
             for(k=j; k<nb-1 ; k++) bw[k]=bw[k+1];
             nb--;
             break;
	   }
	 }
}
/*
printf("pb:");
for(i=0; i<np ; i++) printf(" %d",pb[i]);
printf("\n");
printf("npart:");
for(i=0; i<np ; i++) printf(" %d",npart[i]);
printf("\n");
*/
return(0);
}
   

delchk(a,nseq0,nsite,npsite,nasite,psite,asite,cdnpos,sitef,dop,cdn,ntsite,tsite)
int nseq0,nsite,*npsite,*nasite,*psite,*asite,*cdnpos,*sitef,dop,cdn[4][4][4];
int *ntsite,*tsite;
char **a/*[MAXSITE][MAXOTU]*/;
{
int i,j,k,flg,iw,pol,del,nbs,n1,n2,n3,flg1;
  (*npsite) =0;
  (*nasite) =0;
  (*ntsite) =0;
  /*  printf("ntsite=%d\n",*ntsite);*/
  for(i=0; i<nsite ; i++){
       sitef[i]=0;
       del=0;
       pol=0;
       if( cdnpos[i%3] == 0 ) continue;
       for(j=0; j<nseq0; j++){
          if( del != 0 ) break;
          flg=0;
/*          if( dflg == 1 ) printf("a[%d][%d]=%c %x\n",i,j,a[i][j],a[i][j]); */
          if( a[i][j] == '.' ) {
              a[i][j] = a[i][0];
	    }else{
              for(k=0; k<11 ; k++){
                if( a[i][j] == base[k] ) {
                 a[i][j]=k; 
                 flg=1;
                 break;
               }
              }
             if( flg == 0 ){
               printf("seq %d site %d  invalid base %c %x\n",j+1,i+1,a[i][j],a[i][j]);
               exit(1);
	      }
	    }
           if( a[i][j] > 3 ){
                  del=1;   
                  sitef[i]=1;
                  break;
		}
              if( a[i][j] != a[i][0] ) {
                  pol=1;
                  sitef[i]=2;
		}


	}
    
        if( del != 0  ) continue;
        asite[(*nasite)]=i;
        (*nasite)++;
        if( pol == 1 ){
             psite[(*npsite)]=i;
             (*npsite)++;
	   }
  }
  if( dop >= 18 && dop <= 21 ){
    if( nsite%3 != 0 ){
      printf("dop =%d nsite=%d\n",dop,nsite);
      exit(1);
    }
    *nasite=0;
    *ntsite=0;
    for(i=0; i<nsite/3 ; i++){
     if( sitef[i*3] == 1 ) continue;
     if( sitef[i*3+1] == 1 ) continue;
     if( sitef[i*3+2] == 1 ) continue;
     flg1=0;
     for(j=0; j<nseq0 ; j++){
       n1=a[i*3][j];
       n2=a[i*3+1][j];
       n3=a[i*3+2][j];
       if( cdn[n1][n2][n3] == TER ) {
         flg1=1;
         break;
       }
     }
     if( flg1 == 1 ){
       /*      printf("i=%d n %d %d %d\n",i,n1,n2,n3);*/
      tsite[*ntsite]=i;
      (*ntsite)++;
      continue;
     }
     asite[*nasite] = i;
     (*nasite)++;
    }

  }


    return(0);
}



delchka(a,nseq0,nsite,npsite,nasite,asite,psite,sitef)
int nseq0,nsite,*npsite,*nasite,*asite,*psite,*sitef;
char **a/*[MAXSITE][MAXOTU]*/;
{
int i,j,k,flg,iw,pol,del,nbs;
  (*npsite) =0;
  (*nasite) =0;
  for(i=0; i<nsite ; i++){
       del=0;
       pol=0;
       sitef[i]=0;
       for(j=0; j<nseq0; j++){
          if( del != 0 ) break;
          flg=0;
/*          if( dflg == 1 ) printf("a[%d][%d]=%c %x\n",i,j,a[i][j],a[i][j]); */
          if( a[i][j] == '.' ) {
             a[i][j] = a[i][0];
	   }else{
            for(k=0; k<24 ; k++){
              if( a[i][j] == amn[k] ) {
                 a[i][j]=k; 
      
                flg=1;
                 break;
           
             }
            }
            if( flg == 0 ){
               printf("seq %d site %d  invalid amn %c %x\n",j+1,i+1,a[i][j],a[i][j]);
               exit(1);
	     }
	  }
           if( a[i][j] >=20 ){
                  del=1;   
                  break;
		}
              if( a[i][j] != a[i][0] ) pol=1;


	}
    
        if( del != 0  ){
         sitef[i]=1;
         continue;
       }
        asite[*nasite]=i;
        (*nasite)++;
        if( pol == 1 ){
             sitef[i]=2;
             psite[(*npsite)]=i;
             (*npsite)++;
	   }
     }
    return(0);
}


#include <time.h>
int getseed()
{
long seed;
time_t tm;
time_t time();

      time(&tm);
      seed = tm%3000;
      
      return(seed);
}








chkdist(fp,nseq,maxnm)
FILE *fp;
int *nseq,*maxnm;
{
int i,j,rn,n,notu,nc,n1,n2,state,ch,s1,s2;
float fw;
char b[500],b1[500];


  *maxnm = 0;
  for( ; ; ){
    rn=rdline(fp,b,&n);
    if( rn == -1 ){
        printf("format error");
        exit(-1);
      }
    if( rn == 1 ) continue;
    if( rn == 0 ) break;
  }
   sscanf(b,"%d",&notu);
/* printf("notu=%d\n",notu);   fflush(stdout); */
   if( notu <= 2 ){
      printf("invalid  # otu  %d\n",notu);
      exit(1);
    }
   for(i=0; i<notu ; ){
     rn=rdline(fp,b,&n);
     if( rn == -1 ){
       printf("format error\n");
       exit(-1);
     }
    if( rn == 1 ) continue;
    sscanf(b,"%d %s\n",&nc,b1);
    rn = strlen(b1);
/*   printf("rn=%d %s\n",rn,b1); fflush(stdout); */

    if( rn == 0 ){
        printf("formant error in chkdist otu %d name \n",nc);
        exit(1);
      }
    if( rn > *maxnm ) *maxnm = rn;
    if( nc != i+1 ){
      printf("invalid otu number %d %d\n",i+1,nc);
      exit(1);
    }
    i++;
   }
   nc=0;
   state=0;
   n1=0;
   for(i=0; i<500 ; i++) b1[i]=0;
   for( ; ; ){
     ch=fgetc(fp);
     if( ch == EOF ) break;
     if( ch == ' ' || ch == '\n' || ch == '\t' ) {
      if( state == 1 ){
        sscanf(b1,"%f",&fw);
        nc++;
/*        count(notu,nc,&s1,&s2,uplowflg); */
/*        printf("nc=%d s1=%d s1+s2=%d fw=%f b1=%s n1=%d\n",nc,s1,s1+s2,fw,b1,n1);fflush(stdout); */
        if( nc > notu*(notu-1)/2 ) {
         printf("too many distance\n");
         exit(1);
       }
/*       dist[s1][s1+s2]=fw; */
      state=0;
      }
    }else{
      if( state == 0 ){
         for(i=0; i<500 ; i++) b1[i]=0;
         n1=0;
         state=1;
       }
         b1[n1]=ch;
         n1++;
    }
    }
   *nseq = notu;
   return(0);
}

rdline(fp,b,n)
FILE *fp;
char *b;
int *n;
{
int i,ch,ns;

  *n=0;
  ns=0;
  for( ; ; ){
    ch=fgetc(fp);
    if( ch == EOF ) return(-1);
    b[*n]=ch;
    (*n)++;
    if( ch != '\n' && ch != ' ' ) ns++;
    if( ch == '\n' ) break;
}
  if( ns == 0 ) return(1);
  return(0);
}

  







redist(fp,nseq,fl,dist,uplowflg)
FILE *fp;
int nseq,uplowflg;
char **fl/*[MAXOTU][MAXNM]*/;
double **dist/*[MAXOTU][MAXOTU]*/;
{
int i,j,rn,n,notu,nc,n1,n2,state,ch,s1,s2;
float fw;
char b[500],b1[500];
/* uplowflg :  0 -- upper triangular matrix */
/* uplowflg :  1 -- lower triangular matrix */

/*  printf("uplowflg = %d\n",uplowflg); */
  for( ; ; ){
    rn=rdline(fp,b,&n);
    if( rn == -1 ){
        printf("format error");
        exit(-1);
      }
    if( rn == 1 ) continue;
    if( rn == 0 ) break;
  }
   sscanf(b,"%d",&notu);
/*   printf("notu=%d\n",notu);   fflush(stdout); */
   if( notu <= 2 ){
      printf("invalid  # otu  %d\n",notu);
      exit(1);
    }
   for(i=0; i<notu ; ){
     rn=rdline(fp,b,&n);
     if( rn == -1 ){
       printf("format error\n");
       exit(-1);
     }
    if( rn == 1 ) continue;
    sscanf(b,"%d %s\n",&nc,fl[i]);
/*    printf("%d %s\n",nc,fl[i]);   fflush(stdout); */
    if( nc != i+1 ){
      printf("invalid otu number %d %d\n",i+1,nc);
      exit(1);
    }
    i++;
   }
   nc=0;
   state=0;
   n1=0;

/*   printf("notu=%d\n",notu); */
   for(i=0; i<500 ; i++) b1[i]=0;
   for( ; ; ){
     ch=fgetc(fp);
     if( ch == EOF ) break;
     if( ch == ' ' || ch == '\n' || ch == '\t' ) {
      if( state == 1 ){
        sscanf(b1,"%f",&fw);
        nc++;
        count(notu,nc,&s1,&s2,uplowflg);
        if( uplowflg == 0 ) dist[s1][s1+s2]=fw;
        if( uplowflg == 1 ) dist[s1][s2]=fw;
/*      printf("nc=%d s1=%d s1+s2=%d fw=%f b1=%s n1=%d\n",nc,s1,s1+s2,fw,b1,n1);fflush(stdout);  */

        if( nc > notu*(notu-1)/2 ) {
         printf("too many distance\n");
         exit(1);
       }
       dist[s1][s1+s2]=fw;
       state=0;
      }
    }else{
      if( state == 0 ){
         for(i=0; i<500 ; i++) b1[i]=0;
         n1=0;
         state=1;
       }
         b1[n1]=ch;
         n1++;
    }
    }
/*
   for(i=0; i< nseq ; i++){
    for(j=i+1 ; j< nseq ; j++){
      printf("%d %d %f\n",i,j,dist[i][j]);
    }
  }
*/
   return(0);
}





count(notu,nc,s1,s2,uplowflg)
int notu,nc,*s1,*s2,uplowflg;
{
int nt,n1,n2,n;

if( uplowflg == 0 ){
  nt = notu-1;
  n1=n2=0;
  for( ; ; ){
   if( nc <= nt ){
      *s1=n1;
      *s2=nc;
      return(0);
    }
    nc -= nt;
    nt--;
    n1++;
 }

}

nt =0;
for(n1=1; n1 < notu ; n1++){
 for(n2=0 ; n2 < n1 ; n2++){
  nt++;
  if( nt == nc ){
   *s1 = n2;
   *s2 = n1;
   return(0);
 }
}
}



}
  
upg(nseq,dist,node0,branch0,otu,sij,nclus,dcm)
int nseq,**node0/*[MAXOTU-1][3]*/,*otu/*[MAXOTU]*/,*nclus/*[MAXOTU]*/;
int **sij/*[MAXOTU*(MAXOTU-1)/2][2]*/;
double **dist/*[MAXOTU][MAXOTU]*/,**branch0/*[MAXOTU][3]*/;
double *dcm/*[MAXOTU]*/;
{
int i,j,k,l,nsc,cyc,n1,n2;

double sm,dw1,dw2,dw3;
extern int dflg;


/*  printf("upg\n");
  for(i=0; i<nseq ; i++){
   for(j=0; j<nseq ; j++){
     if(i >= j) printf("         "); 
     if( i < j ) printf(" %f",dist[i][j]);
   }
   printf("\n");

 }
*/


  nsc=nseq;
  for(i=0; i< nseq-1 ; i++){
    for(j=0; j<3 ; j++) node0[i][j]=0;
  }
  for(i=0; i<nseq; i++) {
      otu[i]=i+1;
      nclus[i]=1;
    }
/*  printf("upg\n"); fflush(stdout); */
  for(cyc=0; cyc<nseq-1; cyc++){
     sm = 999999.0;
/*     printf("cyc=%d\n",cyc); fflush(stdout); */
     for(i=0; i<nsc-1; i++){
        for(j=i+1; j<nsc; j++){
          if( sm > dist[i][j] ){
             sm = dist[i][j];
             sij[0][0]=i;
             sij[0][1]=j;
	   }
	}
      }
/*     printf("sij\n"); fflush(stdout); */
/*
     scnt=1;
     for(i=0; i<nsc-1; i++){
        for(j=i+1; j<nsc; j++){
          if( i == sij[0][0] && j == sij[0][1] ) continue;
          if( sm+ACU >= dist[i][j]  &&  dist[i][j] >= sm-ACU ){
             sij[scnt][0]=i;
             sij[scnt][1]=j;
             scnt++;
	   }
	}
      }
*/
/*     printf("sij\n"); fflush(stdout); */
     n1=sij[0][0];
     n2=sij[0][1];

       node0[cyc][0]=otu[n1];
       node0[cyc][1]=otu[n2];
       dcm[cyc]=dist[n1][n2];
       if( otu[n1] <= nseq ){
             branch0[cyc][0]=dist[n1][n2]/2.0;
	   }else{
             branch0[cyc][0]=dist[n1][n2]/2.0 - dcm[otu[n1]-nseq-1]/2.0;
       }
       if( otu[n2] <= nseq ){
             branch0[cyc][1]=dist[n1][n2]/2.0;
	   }else{
             branch0[cyc][1]=dist[n1][n2]/2.0 - dcm[otu[n2]-nseq-1]/2.0;
       }
/*      printf("%d %f %f",cyc,branch0[cyc][0],branch0[cyc][1]); fflush(stdout);*/
		if( dflg == 1 ) printf("tie=%d n1=%d n2=%d\n",n1,n2);
      for(k=0; k<nsc; k++) {
          dw1 = nclus[n1]*nclus[k];
          dw2 = nclus[n2]*nclus[k];
          dw3 = nclus[n1]*nclus[k]+nclus[n2]*nclus[k];
          if( k == n1 || k == n2 ) continue;
          if( n1 < k && n2 < k ) dist[n1][k] = (dist[n1][k]*dw1 + dist[n2][k]*dw2)/dw3;
          if( n1 < k && n2 > k ) dist[n1][k] = (dist[n1][k]*dw1 + dist[k][n2]*dw2)/dw3;
          if( n1 > k && n2 < k ) dist[k][n1] = (dist[k][n1]*dw1 + dist[n2][k]*dw2)/dw3;
          if( n1 > k && n2 > k ) dist[k][n1] = (dist[k][n1]*dw1 + dist[k][n2]*dw2)/dw3;
	}
      otu[n1]=nseq+cyc+1;
      nclus[n1] += nclus[n2];
      for(k=n2; k<nsc-1; k++) {
          otu[k]=otu[k+1];
          nclus[k]=nclus[k+1];
	}
      if( dflg == 1 ) {
         printf("otu:");
         for(k=0; k<nsc ; k++ ) printf(" %d",otu[k]);
         printf("\n");
       }

      for(k=0; k< n2 ; k++){
         for(l=n2+1 ; l< nsc ; l++)  dist[k][l-1] = dist[k][l];
       }
       for(k=n2+1 ; k<nsc-1 ; k++){
         for(l=k+1 ; l<nsc ; l++) dist[k-1][l-1] =dist[k][l];
       }

   
       nsc--;
   }

 cyc=nseq-2;
 if( node0[cyc][0] == 2*nseq-2 ){
      node0[cyc-1][2]=node0[cyc][1];
      branch0[cyc-1][2]=branch0[cyc][0]+branch0[cyc][1];
    }

 if( node0[cyc][1] == 2*nseq-2 ){
      node0[cyc-1][2]=node0[cyc][0];
      branch0[cyc-1][2]=branch0[cyc][0]+branch0[cyc][1];
    }
/*
for(i=0; i<2*nseq-1 ; i++){
  printf("%f %f\n",branch0[i][0],branch0[i][1]);
}
*/
 return(0);
}

upgr(nseq,dist,node0,branch0,otu,sij,nclus,dcm,seed1,accu)
int nseq,**node0/*[MAXOTU-1][3]*/,*otu/*[MAXOTU]*/,*nclus/*[MAXOTU]*/;
long *seed1;
int **sij/*[MAXOTU*(MAXOTU-1)/2][2]*/;
double **dist/*[MAXOTU][MAXOTU]*/,**branch0/*[MAXOTU][3]*/,accu;
double *dcm/*[MAXOTU]*/;
{
int i,j,k,l,nsc,cyc,scnt,n1,n2;
int rn;
double sm,dw1,dw2,dw3;
extern int dflg;
extern float ran1();


  nsc=nseq;
  for(i=0; i< nseq-1 ; i++){
    for(j=0; j<3 ; j++) node0[i][j]=0;
  }
  for(i=0; i<nseq; i++) {
      otu[i]=i+1;
      nclus[i]=1;
    }
  /*  printf("upg\n"); fflush(stdout); */
  for(cyc=0; cyc<nseq-1; cyc++){
     sm = 999999.0;
     /*     printf("cyc=%d\n",cyc); fflush(stdout); */
     for(i=0; i<nsc-1; i++){
        for(j=i+1; j<nsc; j++){
          if( sm > dist[i][j] ){
             sm = dist[i][j];
             sij[0][0]=i;
             sij[0][1]=j;
	   }
	}
      }
/*     printf("sij\n"); fflush(stdout); */
     scnt=1;
     for(i=0; i<nsc-1; i++){
        for(j=i+1; j<nsc; j++){
          if( i == sij[0][0] && j == sij[0][1] ) continue;
          if( sm+accu > dist[i][j]  &&  dist[i][j] > sm-accu ){
             sij[scnt][0]=i;
             sij[scnt][1]=j;
             scnt++;
	   }
	}
      }

     /*     printf("scnt=%d\n",scnt); fflush(stdout);*/
     n1=sij[0][0];
     n2=sij[0][1];
	  if( scnt > 1 ){
		  rn = ran1(seed1)*(float)scnt;
        n1 = sij[rn][0];
        n2 = sij[rn][1];
      }
       node0[cyc][0]=otu[n1];
       node0[cyc][1]=otu[n2];
       dcm[cyc]=dist[n1][n2];
       if( otu[n1] <= nseq ){
             branch0[cyc][0]=dist[n1][n2]/2.0;
	   }else{
             branch0[cyc][0]=dist[n1][n2]/2.0 - dcm[otu[n1]-nseq-1]/2.0;
       }
       if( otu[n2] <= nseq ){
             branch0[cyc][1]=dist[n1][n2]/2.0;
	   }else{
             branch0[cyc][1]=dist[n1][n2]/2.0 - dcm[otu[n2]-nseq-1]/2.0;
       }
/*      printf("%d %f %f",cyc,branch0[cyc][0],branch0[cyc][1]); fflush(stdout);*/
		if( dflg == 1 ) printf("tie=%d n1=%d n2=%d\n",n1,n2);
      for(k=0; k<nsc; k++) {
          dw1 = nclus[n1]*nclus[k];
          dw2 = nclus[n2]*nclus[k];
          dw3 = nclus[n1]*nclus[k]+nclus[n2]*nclus[k];
          if( k == n1 || k == n2 ) continue;
          if( n1 < k && n2 < k ) dist[n1][k] = (dist[n1][k]*dw1 + dist[n2][k]*dw2)/dw3;
          if( n1 < k && n2 > k ) dist[n1][k] = (dist[n1][k]*dw1 + dist[k][n2]*dw2)/dw3;
          if( n1 > k && n2 < k ) dist[k][n1] = (dist[k][n1]*dw1 + dist[n2][k]*dw2)/dw3;
          if( n1 > k && n2 > k ) dist[k][n1] = (dist[k][n1]*dw1 + dist[k][n2]*dw2)/dw3;
	}
      otu[n1]=nseq+cyc+1;
      nclus[n1] += nclus[n2];
      for(k=n2; k<nsc-1; k++) {
          otu[k]=otu[k+1];
          nclus[k]=nclus[k+1];
	}
      if( dflg == 1 ) {
         printf("otu:");
         for(k=0; k<nsc ; k++ ) printf(" %d",otu[k]);
         printf("\n");
       }

      for(k=0; k< n2 ; k++){
         for(l=n2+1 ; l< nsc ; l++)  dist[k][l-1] = dist[k][l];
       }
       for(k=n2+1 ; k<nsc-1 ; k++){
         for(l=k+1 ; l<nsc ; l++) dist[k-1][l-1] =dist[k][l];
       }

   
       nsc--;
   }

 cyc=nseq-2;
 if( node0[cyc][0] == 2*nseq-2 ){
      node0[cyc-1][2]=node0[cyc][1];
      branch0[cyc-1][2]=branch0[cyc][0]+branch0[cyc][1];
    }

 if( node0[cyc][1] == 2*nseq-2 ){
      node0[cyc-1][2]=node0[cyc][0];
      branch0[cyc-1][2]=branch0[cyc][0]+branch0[cyc][1];
    }
/*
for(i=0; i<2*nseq-1 ; i++){
  printf("%f %f\n",branch0[i][0],branch0[i][1]);
}
*/
 return(0);
}


#define M1 259200
#define IA1 7141
#define IC1 54773
#define RM1 (1.0/M1)
#define M2 134456
#define IA2 8121
#define IC2 28411
#define RM2 (1.0/M2)
#define M3 243000
#define IA3 4561
#define IC3 51349
/* generate uniform random number >= 0 && < 1 */
/* if you want generate random number from 0 to n-1
 *  multiply by n
 *  set *idum by any negative value. The sequence is reset.
 */
float ran1(idum)
int *idum;
{
static long ix1,ix2,ix3;
static float r[98];
float temp;
static int iff=0;
int j;

if( *idum < 0 || iff == 0 ){
   iff = 1;
   ix1 = (IC1 - (*idum)) % M1;
   ix1 = (IA1*ix1+IC1) % M1;
   ix2 = ix1 % M2;
   ix1 = (IA1*ix1+IC1) % M1;
   ix3 = ix1 % M3;
   for(j=1 ; j<97 ; j++){
     ix1 =(IA1*ix1+IC1) % M1;
     ix2 =(IA2*ix2+IC2) % M2;
     r[j] =(ix1+ix2*RM2)*RM1;
   }
   *idum = 1;
 }

 ix1 = (IA1*ix1+IC1) % M1;
 ix2 = (IA2*ix2+IC2) % M2;
 ix3 = (IA3*ix3+IC3) % M3;
 j = 1 + ((97*ix3)/M3);
 if( j > 97 || j < 1 ) {
   printf("ran1(): j = %d \n");
   exit(1);
 }
 temp = r[j];
 r[j]=(ix1 + ix2*RM2)*RM1;
 return(temp);
}


 /* The Genetic Codes */
/* The Standard Code (transl_table=1) */

   static char *AAst1 = {"FFLLSSSSYY**CC*WLLLLPPPPHHQQRRRRIIIMTTTTNNKKSSRRVVVVAAAADDEEGGGG"};
static char *Startst1 = {"---M---------------M---------------M----------------------------"};
static char *Base1t1 =  {"TTTTTTTTTTTTTTTTCCCCCCCCCCCCCCCCAAAAAAAAAAAAAAAAGGGGGGGGGGGGGGGG"};
static char *Base2t1 =  {"TTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGG"};
static char *Base3t1 =  {"TCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAG"};
static char *inic[3] = {"AUG","CUG","UUG"};

/* The Vertebrate Mitochondrial Code (transl_table=2) */
static char *AAst2 =    {"FFLLSSSSYY**CCWWLLLLPPPPHHQQRRRRIIMMTTTTNNKKSS**VVVVAAAADDEEGGGG"};
static char *Startst2 = {"--------------------------------MMMM---------------M------------"};
static char *Base1t2  = {"TTTTTTTTTTTTTTTTCCCCCCCCCCCCCCCCAAAAAAAAAAAAAAAAGGGGGGGGGGGGGGGG"};
static char *Base2t2  = {"TTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGG"};
static char *Base3t2  = {"TCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAG"};

/* Bos: AUA <BR>
   Homo: AUA, AUU<BR>
   Mus: AUA, AUU, AUC<BR>
   Coturnix, Gallus: also GUG (Desjardins and Morais, 1991)<BR>
*/
/* The Yeast Mitochondrial Code (transl_table=3) */
static char    *AAst3  = {"FFLLSSSSYY**CCWWTTTTPPPPHHQQRRRRIIMMTTTTNNKKSSRRVVVVAAAADDEEGGGG"};
static char  *Startst3 = {"-----------------------------------M----------------------------"};
static char  *Base1t3  = {"TTTTTTTTTTTTTTTTCCCCCCCCCCCCCCCCAAAAAAAAAAAAAAAAGGGGGGGGGGGGGGGG"};
static char  *Base2t3  = {"TTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGG"};
static char  *Base3t3  = {"TCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAG"};
/*  Saccharomyces cerevisiae, Candida glabrata, Hansenula saturnus,
    Schizosaccharomyces pombe, and Kluyveromyces thermotolerans
   (Clark-Walker and Weiller, 1994)
   The remaining CGN codons are rare in Saccharomyces cerevisiae and
   absent in Candida glabrata (= Torulopsis glabrata)
*/

/* The Mold, Protozoan, and Coelenterate Mitochondrial Code 
and the Mycoplasma/Spiroplasma Code (transl_table=4) */
static char *AAst4  =    {"FFLLSSSSYY**CCWWLLLLPPPPHHQQRRRRIIIMTTTTNNKKSSRRVVVVAAAADDEEGGGG"};
static char *Startst4 =  {"--MM---------------M------------MMMM---------------M------------"};
static char *Base1t4  = {"TTTTTTTTTTTTTTTTCCCCCCCCCCCCCCCCAAAAAAAAAAAAAAAAGGGGGGGGGGGGGGGG"};
static char *Base2t4  = {"TTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGG"};
static char *Base3t4  = {"TCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAG"};
/* Alternative initiation codons 
  Trypanosoma: UUA, UUG, CUG
  Leishmania: AUU, AUA
  Tertrahymena: AUU, AUA, AUG 
  Paramecium: AUU, AUA, AUG, AUC, GUG, GUA(?) 
  (Pritchard et al., 1990)
*/
/* Mycoplasmatales: Mycoplasma, Spiroplasma (Bove et al., 1989);
   Fungi: Emericella nidulans, Neurospora crassa,
   Podospora anserina, Acremonium (Fox, 1987), Candida
   parapsilosis (Guelin et al., 1991), Trichophyton rubrum (de
   Bievre and Dujon, 1992), Dekkera/Brettanomyces, Eeniella (Hoeben
   et al., 1993), and probably Ascobolus immersus, Aspergillus
   amstelodami, Claviceps purpurea, and Protozoa: Trypanosoma brucei, 
   Leishmania tarentolae, Paramecium tetraurelia, Tetrahymena
   pyriformis and probably Plasmodium gallinaceum (Aldritt et al., 1989).

   Metazoa: Coelenterata (Ctenophora and Cnidaria)
   This code is also used for the kinetoplast DNA (maxicircles,
   minicircles).  Kinetoplasts are modified mitochondria (or their
   parts).
   This code is not used in the Acholeplasmataceae and plant-pathogenic
   mycoplasma-like organisms (MLO) (Lim and Sears, 1992)
*/

/* The Invertebrate Mitochondrial Code (transl_table=5) */
static char *AAst5  = {"FFLLSSSSYY**CCWWLLLLPPPPHHQQRRRRIIMMTTTTNNKKSSSSVVVVAAAADDEEGGGG"};
static char *Startst5 = {"---M----------------------------MMMM---------------M------------"};
static char *Base1t5  = {"TTTTTTTTTTTTTTTTCCCCCCCCCCCCCCCCAAAAAAAAAAAAAAAAGGGGGGGGGGGGGGGG"};
static char *Base2t5  = {"TTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGG"};
static char *Base3t5  = {"TCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAG"};
/* The codon AGG is absent in Drosophila. */
/* AUA, AUU
   AUC: Apis (Crozier and Crozier, 1993)
   GUG: Polyplacophora (Boore and Brown, 1994)
   UUG: Ascaris, Caenorhabditis<BR>
*/

/* Nematoda: Ascaris, Caenorhabditis;
   Mollusca: Bivalvia (Hoffmann et al., 1992); Polyplacophora 
   (Boore and Brown, 1994)
   Arthropoda/Crustacea: Artemia (Batuecas et al., 1988);
   Arthropoda/Insecta: Drosophila [Locusta migratoria (migratory locust), 
   Apis mellifera (honeybee)
*/

/* The Ciliate, Dasycladacean and Hexamita Nuclear Code (transl_table=6)*/
static char *AAst6  = {"FFLLSSSSYYQQCC*WLLLLPPPPHHQQRRRRIIIMTTTTNNKKSSRRVVVVAAAADDEEGGGG"};
static char *Startst6 = {"-----------------------------------M----------------------------"};
static char *Base1t6 = {"TTTTTTTTTTTTTTTTCCCCCCCCCCCCCCCCAAAAAAAAAAAAAAAAGGGGGGGGGGGGGGGG"};
static char *Base2t6  = {"TTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGG"};
static char *Base3t6  = {"TCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAG"};
/* Ciliata: Oxytricha and Stylonychia (Hoffman et al. 1995), Paramecium,
   Tetrahymena, Oxytrichidae and probably Glaucoma chattoni.
   Dasycladaceae: Acetabularia (Schneider et al., 1989) and
   Batophora (Schneider and de Groot, 1991).
   Diplomonadida
   Scope: Hexamita inflata, Diplomonadida ATCC50330, and ATCC50380. 
/* The Echinoderm Mitochondrial Code (transl_table=9) */
static char  *AAst9  = {"FFLLSSSSYY**CCWWLLLLPPPPHHQQRRRRIIIMTTTTNNNKSSSSVVVVAAAADDEEGGGG"};
static char  *Startst9 ={" -----------------------------------M----------------------------"};
static char  *Base1t9  = {"TTTTTTTTTTTTTTTTCCCCCCCCCCCCCCCCAAAAAAAAAAAAAAAAGGGGGGGGGGGGGGGG"};
static char  *Base2t9  = {"TTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGG"};
static char  *Base3t9  = {"TCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAG"};
/*  Asterozoa (starfishes) (Himeno et al., 1987)
    Echinozoa (sea urchins) (Jacobs et al., 1988; Cantatore et al., 1989)
  */
/* 10. The Euplotid Nuclear Code (transl_table=10) */
static char  *AAst10  = {"FFLLSSSSYY**CCCWLLLLPPPPHHQQRRRRIIIMTTTTNNKKSSRRVVVVAAAADDEEGGGG"};
static char  *Startst10 = {"-----------------------------------M----------------------------"};
static char  *Base1t10  = {"TTTTTTTTTTTTTTTTCCCCCCCCCCCCCCCCAAAAAAAAAAAAAAAAGGGGGGGGGGGGGGGG"};
static char  *Base2t10  = {"TTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGG"};
static char  *Base3t10  = {"TCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAG"};

/* 11. The Bacterial "Code" (transl_table=11)  */
static char *AAst11  =   {"FFLLSSSSYY**CC*WLLLLPPPPHHQQRRRRIIIMTTTTNNKKSSRRVVVVAAAADDEEGGGG"};
static char *Startst11 = {"---M---------------M------------MMMM---------------M------------"};
static char *Base1t11  = {"TTTTTTTTTTTTTTTTCCCCCCCCCCCCCCCCAAAAAAAAAAAAAAAAGGGGGGGGGGGGGGGG"};
static char *Base2t11  = {"TTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGG"};
static char *Base3t11  = {"TCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAG"};

/* GUG, UUG, AUU, CUG */
/* Prokaryotes including the eubacteria (Kozak, 1983) and archaebacteria
   (Brown et al. 1989; Noelling et al., unpublished).
*/
/* 12. The Alternative Yeast Nuclear Code (transl_table=12) */
static char *AAst12  = {"FFLLSSSSYY**CC*WLLLSPPPPHHQQRRRRIIIMTTTTNNKKSSRRVVVVAAAADDEEGGGG"};
static char *Startst12 = {"-------------------M---------------M----------------------------"};
static char *Base1t12  = {"TTTTTTTTTTTTTTTTCCCCCCCCCCCCCCCCAAAAAAAAAAAAAAAAGGGGGGGGGGGGGGGG"};
static char *Base2t12  = {"TTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGG"};
static char *Base3t12  = {"TCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAG"};

/* 13. The Ascidian Mitochondrial Code (transl_table=13) */
static char *AAst13  = {"FFLLSSSSYY**CCWWLLLLPPPPHHQQRRRRIIMMTTTTNNKKSSGGVVVVAAAADDEEGGGG"};
static char *Startst13 = {"-----------------------------------M----------------------------"};
static char *Base1t13  = {"TTTTTTTTTTTTTTTTCCCCCCCCCCCCCCCCAAAAAAAAAAAAAAAAGGGGGGGGGGGGGGGG"};
static char *Base2t13  = {"TTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGGTTTTCCCCAAAAGGGG"};
static char *Base3t13  = {"TCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAGTCAG"};
/*Ascidiacea (sea squirts): Pyuridae (Durrheim et al. 1993; Yokobori et al., 1993)
*/
/* 14. The Flatworm Mitochondrial Code (transl_table=14) */
/* 15. The Flatworm Mitochondrial Code (transl_table=14) */





codonset(ntable,cdn)
int ntable;
int cdn[4][4][4];
{
char amino[64],start[64],base1[64],base2[64],base3[64];


int i,j,k;

     switch(ntable){
      case 1: for(i=0; i<64 ; i++){
                 amino[i] = AAst1[i];
                 start[i] = Startst1[i];
                 base1[i] = Base1t1[i];
                 base2[i] = Base2t1[i];
                 base3[i] = Base3t1[i];
              }
              break;
      case 2: for(i=0; i<64 ; i++){
                 amino[i] = AAst2[i];
                 start[i] = Startst2[i];
                 base1[i] = Base1t2[i];
                 base2[i] = Base2t2[i];
                 base3[i] = Base3t2[i];
              }
              break;
      case 3: for(i=0; i<64 ; i++){
                 amino[i] = AAst3[i];
                 start[i] = Startst3[i];
                 base1[i] = Base1t3[i];
                 base2[i] = Base2t3[i];
                 base3[i] = Base3t3[i];
              }
              break;
      case 4: for(i=0; i<64 ; i++){
                 amino[i] = AAst4[i];
                 start[i] = Startst4[i];
                 base1[i] = Base1t4[i];
                 base2[i] = Base2t4[i];
                 base3[i] = Base3t4[i];
              }
              break;
      case 5: for(i=0; i<64 ; i++){
                 amino[i] = AAst5[i];
                 start[i] = Startst5[i];
                 base1[i] = Base1t5[i];
                 base2[i] = Base2t5[i];
                 base3[i] = Base3t5[i];
              }
              break;
      case 6: for(i=0; i<64 ; i++){
                 amino[i] = AAst6[i];
                 start[i] = Startst6[i];
                 base1[i] = Base1t6[i];
                 base2[i] = Base2t6[i];
                 base3[i] = Base3t6[i];
              }
              break;

      case 9: for(i=0; i<64 ; i++){
                 amino[i] = AAst9[i];
                 start[i] = Startst9[i];
                 base1[i] = Base1t9[i];
                 base2[i] = Base2t9[i];
                 base3[i] = Base3t9[i];
              }
              break;
      case 10: for(i=0; i<64 ; i++){
                 amino[i] = AAst10[i];
                 start[i] = Startst10[i];
                 base1[i] = Base1t10[i];
                 base2[i] = Base2t10[i];
                 base3[i] = Base3t10[i];
              }
              break;

      case 11: for(i=0; i<64 ; i++){
                 amino[i] = AAst11[i];
                 start[i] = Startst11[i];
                 base1[i] = Base1t11[i];
                 base2[i] = Base2t11[i];
                 base3[i] = Base3t11[i];
              }
              break;

      case 12: for(i=0; i<64 ; i++){
                 amino[i] = AAst12[i];
                 start[i] = Startst12[i];
                 base1[i] = Base1t12[i];
                 base2[i] = Base2t12[i];
                 base3[i] = Base3t12[i];
              }
              break;
      case 13: for(i=0; i<64 ; i++){
                 amino[i] = AAst13[i];
                 start[i] = Startst13[i];
                 base1[i] = Base1t13[i];
                 base2[i] = Base2t13[i];
                 base3[i] = Base3t13[i];
   }
              break;
     default: printf("invalid table number %d\n");
              exit(1);

     }

     for(i=0; i<64 ; i++){
       for(j=0; j<4 ; j++){
         if( base1[i] == base[j] ){
             base1[i] = j;
             break;
	 }
       }
       for(j=0; j<4 ; j++){
         if( base2[i] == base[j] ){
             base2[i] = j;
             break;
	 }
       }
       for(j=0; j<4 ; j++){
         if( base3[i] == base[j] ){
             base3[i] = j;
             break;
	 }
       }
       for(j=0; j<21 ; j++){
         if( amino[i] == amn1[j] ) {
            amino[i] = j;
            break;
	 }
       }
       /*      printf("i=%d %d %d %d %d\n",i,base1[i],base2[i],base3[i],amino[i]);*/
     }
    
     for(i=0; i<64 ; i++){
      cdn[base1[i]][base2[i]][base3[i]] = amino[i];
     }
     /*
     for(i=0; i<4 ; i++){
       for(j=0; j<4 ; j++){
	 for(k=0; k<4 ; k++){
           printf("cdn[%d][%d][%d]=%d ter=%d\n",i,j,k,cdn[i][j][k],TER);
	 }
       }
     }
     */

     /*    printf("codonset\n"); fflush(stdout);             */
   return(0);
}

calsyn(nseq,a,fl,nasite,rsite,dist,dop,fpo,bootflg,pairwiseflg,sitef,cdn,pflg,maxnm)
FILE *fpo;
int nseq,nasite,*rsite,dop,bootflg,pairwiseflg,*sitef,cdn[4][4][4],pflg,maxnm;
char **a,**fl;
double **dist;
{
int i,j,k,inap;
double dsyn1,dnosyn1,dsyn2,dnosyn2,syn,nsyn,ps,pn,ds,dn;
double getnsite();
   inap=0;
  if( pflg == 1 ){
    for(k=0; k<maxnm*2+4 ; k++) fprintf(fpo," ");
    fprintf(fpo,"synsite nsynste synchg nsynch ps    pn    ds    dn\n");
  }
for(i=0; i<nseq-1 ; i++){
  dsyn1=getnsite(nasite,rsite,a,i,cdn);
  dnosyn1 = (double)(nasite*3)-dsyn1;
  /*  printf("calsyn %d dsyn1=%f dnosyn1=%f\n",i,dsyn1,dnosyn1); fflush(stdout);*/
  for(j=i+1; j<nseq ; j++){
    dsyn2=getnsite(nasite,rsite,a,j,cdn);
    dnosyn2 = (double)(nasite*3)-dsyn2;
    getsync(nasite,rsite,a,i,j,cdn,&syn,&nsyn);
    ps = 2.*syn/(dsyn1 + dsyn2);
    pn = 2.*nsyn/(dnosyn1 + dnosyn2);
    ds =  -0.75*log(1.0 - ps*4./3.);
    dn =  -0.75*log(1.0 - pn*4./3.);
    if( syn <= ACU ) ds = 0.;
    if( nsyn <= ACU ) dn = 0.;
    if( pflg == 1 ) {
     fprintf(fpo,"%s",fl[i]);
     for(k=0; k< maxnm-strlen(fl[i]) ; k++) fprintf(fpo," ");
     fprintf(fpo," vs");
     fprintf(fpo," %s",fl[j]);
     for(k=0; k< maxnm-strlen(fl[j]) ; k++) fprintf(fpo," ");
     fprintf(fpo,"%7.2f %7.2f %6.2f %6.2f %5.3f %5.3f %5.3f %5.3f\n",(dsyn1+dsyn2)/2.,(dnosyn1+dnosyn2)/2.,syn,nsyn,ps,pn,ds,dn); fflush(stdout);
    }
    switch(dop){
      case 18: dist[i][j]=dist[j][i]==ps; break;
      case 19: dist[j][i]=dist[i][j]=pn; break;
      case 20: if( 1.0 - ps*4./3. <= ACU ) {
                 if( bootflg == 1 ) return(1);
                 inap++;
               }
               dist[i][j]=dist[j][i]= ds; break;
      case 21: if( 1.0 - pn*4./3. <= ACU ){
                 if( bootflg == 1 ) return(1);
                 inap++;
               }
               dist[i][j]=dist[j][i]= dn; break;
    }
  }
}
return(inap);
}

double getnsite(nasite,rsite,a,nseqn,cdn)
int nasite, *rsite,nseqn,cdn[4][4][4];
char **a;
{
int i,j,k,n[3],nc1,nc2,nc3,np1,np2,np3;
double dsyn,dsyn1;
dsyn=0.;
for(i=0; i<nasite; i++){
  for(j=0; j<3 ; j++) n[j] = a[rsite[i]*3+j][nseqn];
    nc1=nc2=nc3=0;
    np1=np2=np3=0;
    for(j=0; j<4 ; j++){
      if( j == n[0] ) continue;
      if( cdn[j][n[1]][n[2]] == TER ) continue;
      np1++;
      if( cdn[j][n[1]][n[2]] == cdn[n[0]][n[1]][n[2]] ) nc1++;
    }
    for(j=0; j<4 ; j++){
      if( j == n[1] ) continue;
      if( cdn[n[0]][j][n[2]] == TER ) continue;
      np2++;
      if( cdn[n[0]][j][n[2]] == cdn[n[0]][n[1]][n[2]] ) nc2++;
    }
    for(j=0; j<4 ; j++){
      if( j == n[2] ) continue;
      if( cdn[n[0]][n[1]][j] == TER ) continue;
      np3++;
      if( cdn[n[0]][n[1]][j] == cdn[n[0]][n[1]][n[2]] ) nc3++;
    }
    dsyn1 = (double)nc1/(double)np1 + (double)nc2/(double)np2 + (double)nc3/(double)np3;
    /*    printf("%c%c%c  dsyn1=%f nc %d %d %d np %d %d %d\n",base[n[0]],base[n[1]],base[n[2]],dsyn1,nc1,nc2,nc3,np1,np2,np3);*/
    dsyn += dsyn1;
}

return(dsyn);
}

getsync(nasite,rsite,a,nseq1,nseq2,cdn,syn,nsyn)
int nasite,*rsite,nseq1,nseq2,cdn[4][4][4];
char **a;
double *syn,*nsyn;
{
int i,j,c1[3],c2[3],nc,cp[3],np;
double syn1,nsyn1;
*syn=*nsyn=0.;
np=0;
for(i=0; i< nasite; i++){
  for(j=0; j<3 ; j++){
     c1[j] = a[rsite[i]*3+j][nseq1]; 
     c2[j] = a[rsite[i]*3+j][nseq2]; 
  }
  nc=0;
  for(j=0; j<3 ; j++){
    if( c1[j] != c2[j] ) {
      cp[nc]=j;
      nc++;
    }
  }
  
   nsyn1 = syn1 = 0.;
  switch(nc){
     case 1:  if( cdn[c1[0]][c1[1]][c1[2]] == cdn[c2[0]][c2[1]][c2[2]] ) syn1 += 1.;
              else nsyn1 += 1.;
              break;       
     case 2:  syn1=nsyn1=0.;
              np=0;
              switch(cp[0]+cp[1]){
               case 1:
       		 /*  1 - 2 */
		 if( cdn[c2[0]][c1[1]][c1[2]] != TER ) {
                       if( cdn[c1[0]][c1[1]][c1[2]] == cdn[c2[0]][c1[1]][c2[2]] ) syn1 += 1.;
                       else nsyn1 += 1.;
                       if( cdn[c2[0]][c1[1]][c1[2]] == cdn[c2[0]][c2[1]][c1[2]] ) syn1 += 1.;  
                       else nsyn1 += 1.;
                       np++;
		 }
       		 /*  2 - 1 */
		 if( cdn[c1[0]][c2[1]][c1[2]] != TER ){
                       if( cdn[c1[0]][c1[1]][c1[2]] == cdn[c1[0]][c2[1]][c1[2]] ) syn1 += 1.;
                       else nsyn1 += 1.;
                       if( cdn[c1[0]][c2[1]][c1[2]] == cdn[c2[0]][c2[1]][c1[2]] ) syn1 += 1.;  
                       else nsyn1 += 1.;
                       np++;
		 }
                       syn1 /= np; nsyn1 /= np;

                       break;       
               case 2:
		 /* 1 - 3 */
		 if( cdn[c2[0]][c1[1]][c1[2]] != TER ){
                       if( cdn[c1[0]][c1[1]][c1[2]] == cdn[c2[0]][c1[1]][c1[2]] ) syn1 += 1.;
                       else nsyn1 += 1.;
                       if( cdn[c2[0]][c1[1]][c1[2]] == cdn[c2[0]][c1[1]][c2[2]] ) syn1 += 1.;  
                       else nsyn1 += 1.;
                       np++;
		 }
		 /* 3 - 1 */
		 if( cdn[c1[0]][c1[1]][c2[2]] != TER ){
                       if( cdn[c1[0]][c1[1]][c1[2]] == cdn[c1[0]][c1[1]][c2[2]] ) syn1 += 1.;
                       else nsyn1 += 1.;
                       if( cdn[c1[0]][c1[1]][c2[2]] == cdn[c2[0]][c1[1]][c2[2]] ) syn1 += 1.;  
                       else nsyn1 += 1.;
                       np++;
		 }
                       syn1 /= np; nsyn1 /= np;
                       break;       

                 
               case 3:
                 /* 2 - 3 */
		 if( cdn[c1[0]][c2[1]][c1[2]] != TER ){
                       if( cdn[c1[0]][c1[1]][c1[2]] == cdn[c1[0]][c2[1]][c1[2]] ) syn1 += 1.;
                       else nsyn1 += 1.;
                       if( cdn[c1[0]][c2[1]][c1[2]] == cdn[c1[0]][c2[1]][c2[2]] ) syn1 += 1.;  
                       else nsyn1 += 1.;
                       np++;
		 }
                 /* 3 - 2 */
		 if( cdn[c1[0]][c1[1]][c2[2]] != TER ){
                       if( cdn[c1[0]][c1[1]][c1[2]] == cdn[c1[0]][c1[1]][c2[2]] ) syn1 += 1.;
                       else nsyn1 += 1.;
                       if( cdn[c1[0]][c1[1]][c2[2]] == cdn[c1[0]][c2[1]][c2[2]] ) syn1 += 1.;  
                       else nsyn1 += 1.;
                       np++;
		 }
                       syn1 /= np; nsyn1 /= np;

                       break;       
	      default: printf("invalid number cp %d %d\n",cp[0],cp[1]);

	      }
       
              break;
  case 3:
               np=0;              
               syn1=nsyn1=0.;
	       /* 1 - 2 - 3 */

               if( cdn[c2[0]][c1[1]][c1[2]] != TER && cdn[c2[0]][c2[1]][c1[2]] != TER){
               if( cdn[c1[0]][c1[1]][c1[2]] == cdn[c2[0]][c1[1]][c1[2]] ) syn1 += 1.; else nsyn1 += 1.;
               if( cdn[c2[0]][c1[1]][c1[2]] == cdn[c2[0]][c2[1]][c1[2]] ) syn1 += 1.; else nsyn1 += 1.;
               if( cdn[c2[0]][c2[1]][c1[2]] == cdn[c2[0]][c2[1]][c2[2]] ) syn1 += 1.; else nsyn1 += 1.;
                   np++;
	       }
	       /* 1 - 3 - 2 */
               if( cdn[c2[0]][c1[1]][c1[2]] != TER && cdn[c2[0]][c1[1]][c2[2]] != TER){
               if( cdn[c1[0]][c1[1]][c1[2]] == cdn[c2[0]][c1[1]][c1[2]] ) syn1 += 1.; else nsyn1 += 1.;
               if( cdn[c2[0]][c1[1]][c1[2]] == cdn[c2[0]][c1[1]][c2[2]] ) syn1 += 1.; else nsyn1 += 1.;
               if( cdn[c2[0]][c1[1]][c2[2]] == cdn[c2[0]][c2[1]][c2[2]] ) syn1 += 1.; else nsyn1 += 1.;
                  np++;
	       }
	       /* 2 - 1 - 3 */
               if( cdn[c1[0]][c2[1]][c1[2]] != TER && cdn[c2[0]][c2[1]][c1[2]] != TER){
               if( cdn[c1[0]][c1[1]][c1[2]] == cdn[c1[0]][c2[1]][c1[2]] ) syn1 += 1.; else nsyn1 += 1.;
               if( cdn[c1[0]][c2[1]][c1[2]] == cdn[c2[0]][c2[1]][c1[2]] ) syn1 += 1.; else nsyn1 += 1.;
               if( cdn[c2[0]][c2[1]][c1[2]] == cdn[c2[0]][c2[1]][c2[2]] ) syn1 += 1.; else nsyn1 += 1.;
                  np++;
	       }
	       /* 2 - 3 - 1 */
               if( cdn[c1[0]][c2[1]][c1[2]] != TER && cdn[c1[0]][c2[1]][c2[2]] != TER){
               if( cdn[c1[0]][c1[1]][c1[2]] == cdn[c2[0]][c1[1]][c1[2]] ) syn1 += 1.; else nsyn1 += 1.;
               if( cdn[c1[0]][c2[1]][c1[2]] == cdn[c1[0]][c2[1]][c2[2]] ) syn1 += 1.; else nsyn1 += 1.;
               if( cdn[c1[0]][c2[1]][c2[2]] == cdn[c2[0]][c2[1]][c2[2]] ) syn1 += 1.; else nsyn1 += 1.;
                  np++;
	       }
	       /* 3 - 1 - 2 */
               if( cdn[c1[0]][c1[1]][c2[2]] != TER && cdn[c2[0]][c1[1]][c2[2]] != TER){
               if( cdn[c1[0]][c1[1]][c1[2]] == cdn[c1[0]][c1[1]][c2[2]] ) syn1 += 1.; else nsyn1 += 1.;
               if( cdn[c1[0]][c1[1]][c2[2]] == cdn[c2[0]][c1[1]][c2[2]] ) syn1 += 1.; else nsyn1 += 1.;
               if( cdn[c2[0]][c1[1]][c2[2]] == cdn[c2[0]][c2[1]][c2[2]] ) syn1 += 1.; else nsyn1 += 1.;
                  np++;
	       }
	       /* 3 - 2 - 1 */
               if( cdn[c1[0]][c1[1]][c2[2]] != TER && cdn[c1[0]][c2[1]][c2[2]] != TER){
               if( cdn[c1[0]][c1[1]][c1[2]] == cdn[c1[0]][c1[1]][c2[2]] ) syn1 += 1.; else nsyn1 += 1.;
               if( cdn[c1[0]][c1[1]][c2[2]] == cdn[c2[0]][c2[1]][c1[2]] ) syn1 += 1.; else nsyn1 += 1.;
               if( cdn[c2[0]][c2[1]][c1[2]] == cdn[c2[0]][c2[1]][c2[2]] ) syn1 += 1.; else nsyn1 += 1.;
                np++;
	       }
                  syn1 /= np;
                  nsyn1 /= np;
  }

  /*  printf("%d nc=%d %c%c%c %c%c%c np=%d\n",i,nc,base[c1[0]],base[c1[1]],base[c1[2]], 
base[c2[0]],base[c2[1]],base[c2[2]],np);*/

   *syn += syn1;
   *nsyn += nsyn1;
}

return(0);
}
  

#define Width  80

#define DPRE    6

prdist(fpo,nseq, dist , ncdist)

FILE *fpo;

int nseq,ncdist;

double **dist;

{

double dw;

int i, j, k,l, n,iw,ia,nt,na,n1,n2;

char b[10],cw,b1[10];



  fprintf(fpo,"\n\nDistance matrix\n");

  dw = -99999.0;

  for(i=0; i< nseq ; i++){

	for(j=i+1; j< nseq ; j++){

	  if( dw < dist[i][j] ) dw = dist[i][j];

	}

  }



  iw = dw;

  for(i=0; ;){

	 iw /= 10;

	 if( iw == 0 ) break;

	 i++;

  }

  ia = i+1+ncdist+1;

  cw = '%';

  for(i=0; i< 10 ; i++ ){

	 b[i]=b1[i]=0;

	 }

	 sprintf(b," %c%d.%df",cw,ia,ncdist);

	 sprintf(b1," %c%dd",cw,ia);

  n = Width / (ia+1);

  nt = (nseq-1)/n;

  na = (nseq-1)%n;

  for(i=0; i< nt+1 ; i++){

	 if( i == 0 ) n1 = 0;

	 else n1 = i*n;

	 if( i == nt ) n2 = i*n+na;

	 else n2 = (i+1)*n;

	 fprintf(fpo,"     ");

	 for(k=n1+1; k<=n2 ; k++) fprintf(fpo,b1,k+1);

	 fprintf(fpo,"\n");



	 for(j=0; j< n2 ; j++){

		fprintf(fpo,"%5d",j+1);

		for(k=n1+1; k<=n2 ; k++){

		 if( j >= k ) {

			  for(l=0; l< ia+1 ; l++) fprintf(fpo," ");

		 }else{

		  fprintf(fpo,b,dist[j][k]);

		 }

		}

		fprintf(fpo,"\n");

	 }



  }



  return(0);

 }








           










           






















  









































main(argc,argv)
int argc;
char **argv;
{
FILE *fpo=stdout,*fpi,*fpe=stderr,*fpb=stdin;
int i,j,k,nc,nc1,nc2,opt,fin,ifc,sc,rn,nln,trn,n,flg,colon,numf,nlm,ndat,nng[9];
int nseq,**node/*[MAXOTU-2][3]*/,**nodeb/*[MAXOTU-2][3]*/,nsite,seed,ncor,emp,tief,ntie,distflg,upgflg,uplowflg,seed1;
float fw;
int lun,nuns,*npart/*[MAXOTU-3]*/;
double **dist/*[MAXOTU][MAXOTU]*/,**branch0/*[MAXOTU][3]*/,**branchb/*[MAXOTU][3]*/,gamma=1.0,accu;
double bsum;
char **fl/*[MAXOTU][MAXNM]*/,**a/*[MAXSITE][MAXOTU]*/,br1[10],br2[10],b[1500];
char *del/*[MAXSITE]*/;
char **part/*[MAXOTU-3][MAXOTU]*/,**partb/*[MAXOTU-3][MAXOTU]*/;
Nodc **nodes/*[MAXOTU-2]*/;
int nbn,ndel,**bri/*[MAXOTU-3][2]*/,**brib/*[MAXOTU-3][2]*/,dop,nasite,nboot,*asite/*[MAXSITE]*/,*psite/*[MAXSITE]*/,npsite,*sitef/*[MAXSITE]*/,maxnm;
int bootflg,pairwiseflg;
int ntsite,*tsite,pflg,ncdist;
int *rsite/*[MAXSITE]*/,nw[3],nb,n1,n2,ninap=0,cdnpos[3],iw,cdn[4][4][4],ntable;
static char *distop[23]={"JC distance","K2P distance","Tajima Nei distance","Tamura distance","Gamma distance","amino Poisson","amino p-distance","amino Gamma","Tamura Nei","Tamura Nei Gamma","p-distance","p-distance with gap","V(proportion)","V K2P","V K2P gamma","V Hasegawa","V Hasegawa gamma","number of difference","synonymous p(Nei and Gojobori)","nonsynonymous p (Nei and Gojobori)",
"synonymous d(Nei and Gojobori)","nonsynonymous d (Nei and Gojobori)","amino acid equal input"};
static char *cdntable[6]={"Standard Code","Vertebrate Mitochondrial Code","Yeast Mitochondrial Code","Mold, Protozoan, and Coelenterate Mitochondrial Code","Invertebrate Mitochondrial Code","Ciliate, Dasycladacean and Hexamita Nuclear Code"};
/* njt */
int *otu,**spair,*sw,*pb,*npw,*bw,*nclus;
double *st,*dcm,*rij;
char *ncn,*rlo,*rli,*chf,*pw1,*pw2;


int *ivector(),**imatrix();
char *cvector(),**cmatrix();
double *dvector(),**dmatrix();
Nodc **nvector();
dop=0;
pflg=0;
ntable = 1;
  distflg = 0;
  upgflg = 0;
  uplowflg = 0;
  pairwiseflg=0;
  ncdist = 6;
  accu = ACU;
  cdnpos[0]=cdnpos[1]=cdnpos[2]=1;
  seed=getseed();
   dop=0;
   nboot=0;
   if( argc == 1 ){
     printf("njboot inputfile -b[bootstrap number] -d[distance option] -o[output file] -s[seed] -pairwise -upg -dist -upper -lower -a[tie torrelance for bootstrap] -t[codon table] -p[print distance matrix] -n[number of digits after decimal point for printed distance]\n");
     printf("distance option\n");
     for(i=0; i<22 ; i++){
       printf("%d    %s\n",i,distop[i]);
     }
     exit(1);
   }
  
   if( argc == 2 && strcmp(argv[1],"-t") == 0 ){
     printf("njboot codon tables\n");
     for(i=0; i<6 ; i++){
       printf("%d %s\n",i+1,cdntable[i]);
     }
     exit(0);

   }
   for(i=1; i<argc ; i++){
     if( argv[i][0] == '-' ){
      if( strcmp(argv[i]+1,"dist") == 0 ){
          distflg=1;
          continue;
	}
      if( strcmp(argv[i]+1,"upg") == 0 ){
          upgflg=1;
          continue;
	}
      if( strcmp(argv[i]+1,"upper") == 0 ){
          uplowflg=0;
          continue;
	}
      if( strcmp(argv[i]+1,"lower") == 0 ){
          uplowflg=1;
          continue;
	}
      if( strcmp(argv[i]+1,"pairwise") == 0 ){
          pairwiseflg=1;
          continue;
	}
      switch( argv[i][1]){
       case 'o' : if((fpo=fopen(argv[i]+2,"w")) == NULL ) {
                    fprintf(fpe,"Can't open output-file:%s\n",argv[i]+2);
                    exit(1);
                  }
                  break;
       case 'd' :  sscanf(argv[i]+2,"%d",&dop);
                   if( dop > 22 || dop < 0 ){
                      fprintf(fpe,"invalid option\n",dop);
                      exit(1);
                   }
                  break;


       case 'c' :  cdnpos[0]=cdnpos[1]=cdnpos[2]=0;
                   if( argv[i][2] >= '0' && argv[i][2] <= '3' ){
                     sscanf(argv[i]+2,"%d",&iw);
                     cdnpos[iw-1]=1;
                   }
                   for(j=i+1 ; j<argc ; j++){
                     if( argv[j][0] == '-' ) break;
                     if( argv[j][0] >= '0' && argv[j][0] <= '3' ){
                     sscanf(argv[j],"%d",&iw);
                     cdnpos[iw-1]=1;
                     i++;
                   }
		   }
                  break;

       case 'g' :  sscanf(argv[i]+2,"%f",&fw);
                   if( fw < 0.0 ){
                      fprintf(fpe,"invalid option gamma=%f\n",fw);
                      exit(1);
                   }
                  gamma=fw;
                  break;
       case 'b' :  sscanf(argv[i]+2,"%d",&nboot);
                  break;
       case 's' :  sscanf(argv[i]+2,"%d",&seed);
                   break;
       case 'n' :  sscanf(argv[i]+2,"%d",&ncdist);
                   break;
       case 't' :  sscanf(argv[i]+2,"%d",&ntable);
                  break;
       case 'p' : pflg=1;
                  break;
       case 'a' :  sscanf(argv[i]+2,"%fl",&accu);
                   break;
       case 'u' :  if(argv[i][2] == 0 ){
                     dflg=1;
                     break;
                   }
                   sscanf(argv[i]+2,"%d",&dflg);
                   break;

       default :  fprintf(fpe,"invalid argument",argv[i]);
                  exit(1);
      }
     }else{
      if((fpi=fopen(argv[i],"r")) == NULL ){
                fprintf(fpe,"Can't open input-file:%s\n",argv[i]);
                exit(1);
      }
      fin=i;
      ifc++;


     }
   }

/*  printf("end of arguments\n");  */

  if( ifc == 0 ){
      fprintf(fpe,"no input-file\n");
      exit(1);
   }
  ifc=0;
  sc=0;
 nseq=0;
 nln=0;

if( distflg == 1 ) nboot = 0;
if( distflg == 0 ) checkfl(fpi,&nseq,&nsite,&maxnm);
if( distflg == 1 ) chkdist(fpi,&nseq,&maxnm);
fclose(fpi);
if( (fpi= fopen(argv[fin],"r")) == NULL ){
  fprintf(fpo,"Can't open file %s\n",argv[fin]);
  exit(1);
}
/* printf("maxnm=%d\n",maxnm);  */

if( upgflg == 0 ){
  node = imatrix(nseq-2,3);
  nodeb = imatrix(nseq-2,3);
  npart = ivector(nseq-3);
  part = cmatrix(nseq-3,nseq);
  partb = cmatrix(nseq-3,nseq);
  nodes = nvector(nseq-2);
  bri = imatrix(nseq-3,2);
  brib = imatrix(nseq-3,2);
}else  {
  node = imatrix(nseq-1,3);
  nodeb = imatrix(nseq-1,3);
  npart = ivector(nseq-1);
  part = cmatrix(nseq-1,nseq);
  partb = cmatrix(nseq-1,nseq);
  nodes = nvector(nseq-1);
  bri = imatrix(nseq-1,2);
  brib = imatrix(nseq-1,2);
}
dist = dmatrix(nseq,nseq);
branch0 = dmatrix(nseq,3);
if( nboot > 0 ) branchb = dmatrix(nseq,3);
fl = cmatrix(nseq,maxnm+1);
if( distflg == 0 ){
  del = cvector(nsite);
  a = cmatrix(nsite,nseq);
  asite = ivector(nsite);
  psite = ivector(nsite);
  sitef = ivector(nsite);
  rsite = ivector(nsite);
}
otu = ivector(nseq);
if( upgflg == 1 ) nclus = ivector(nseq);

spair = imatrix(nseq*(nseq-1)/2,2);
sw = ivector(nseq*(nseq-1)/2);
st = dvector(nseq*(nseq-1)/2);
dcm = dvector(nseq);
rij = dvector(nseq);
ncn = cvector(nseq-2);
rlo = cvector(nseq);
rli = cvector(nseq-2);
chf = cvector(nseq-2);
pb = ivector(nseq-3);
npw = ivector(nseq-3);
bw = ivector(nseq-3);
pw1 = cvector(nseq);
pw2 = cvector(nseq);
if( dop >= 18 && dop <= 21 ) tsite = ivector(nsite/3);

for(i=0; i<nseq ; i++){
 for(j=0; j<maxnm+1 ; j++) fl[i][j]=0;
}

if( dop >= 18 && dop <= 21 ) codonset(ntable,cdn);
if( distflg == 0 ){
 rdseq(fpi,nseq,nsite,a,fl,maxnm);
  ndel=0;
  if( dop >=5 && dop <= 7 || dop == 22 ) delchka(a,nseq,nsite,&npsite,&nasite,asite,psite,sitef);
  else delchk(a,nseq,nsite,&npsite,&nasite,psite,asite,cdnpos,sitef,dop,cdn,&ntsite,tsite);
}
if( distflg == 1 ) redist(fpi,nseq,fl,dist,uplowflg);

   if( nboot > 0 ) fprintf(fpo,"   %d sequences     %d bootstraping\n",nseq,nboot);
/*
   for(i=0; i<nseq ; i++ ){
     printf("%s ",fl[i]);
     for(j=0; j<nasite ; j++){
       printf("%c",base[a[asite[j]][i]]);
     }
     printf("\n");
   }
*/
   if( nboot == 0 ) fprintf(fpo,"   %d sequences\n",nseq);
   for(i=0; i<nseq ; i++){
     fprintf(fpo,"%d %s\n",i+1,fl[i]);
    }
    fflush(fpo);
/*     srandom(seed); */
     seed1 = -seed;
     ran1(&seed1);
     /*     printf("pflg =%d\n",pflg);*/

     bootflg = 0;
     for(i=0; i< nseq-3 ; i++) npart[i]=0;
/*      printf("check nseq=%d\n",nseq); */
        if( distflg == 0 ) { 
          rn=caldist(nseq,a,fl,nasite,asite,npsite,psite,dist,dop,fpo,gamma,bootflg,pairwiseflg,sitef,cdn,pflg,maxnm);
/*        printf("caldist end\n"); fflush(stdout);  */
           if( rn == -1 ) {
           printf("distance was inapplicable\n");
           exit(1);
         }
      }
     if( upgflg == 0 ) njt(nseq,dist,node,branch0,otu,spair,sw,st,dcm,rij); 
     if( upgflg == 1 ) upg(nseq,dist,node,branch0,otu,spair,nclus,dcm);
     /*     printf("njt end\n"); fflush(stdout);*/

      njtndp(nseq,node,nodes,ncn);
      parti(nseq,nodes,part,bri,rlo,rli,chf);

      bootflg=1;
      for(nbn=0; nbn < nboot ; ){
	/*         printf("nbn=%d\n",nbn); fflush(stdout);*/
         ressite(nasite,asite,rsite,psite,&npsite,sitef,&seed1,dop);
         rn=caldist(nseq,a,fl,nasite,rsite,npsite,psite,dist,dop,fpo,gamma,bootflg,pairwiseflg,sitef,cdn,pflg,maxnm);

	 /*         printf("caldist\n",nbn); fflush(stdout);*/

         if( rn == -1 ) {
           ninap++;
           continue;
         }
         if( upgflg == 0 ) njr(nseq,dist,nodeb,branchb,otu,spair,sw,st,dcm,rij,&seed1,accu); 
         if( upgflg == 1 ) upgr(nseq,dist,nodeb,branchb,otu,spair,nclus,dcm,&seed1,accu);
	 /*         printf("upgr\n",nbn); fflush(stdout);*/
         njtndp(nseq,nodeb,nodes,ncn);
         parti(nseq,nodes,partb,brib,rlo,rli,chf);
         cpart(nseq,part,partb,npart,pb,npw,bw,pw1,pw2);
         nbn++;
       }
      
      bsum=0.;
      for(i=0; i<nseq-2 ; i++){
       nb=2;
       if( i == nseq-3 ) nb=3;
       for(j=0; j<nb ; j++){
          if( node[i][j] <= nseq ) nw[j]= nboot;
          if( node[i][j]  > nseq ) {
              n1=i+1;
              n2=node[i][j]-nseq;
              if( n1 > n2 ){
                  nc = n1;
                  n1=n2;
                  n2=nc;
		}
               for(k=0; k<nseq-3 ; k++){
                 if( bri[k][0] == n1 && bri[k][1] == n2 ) {
                    nw[j] = npart[k];
                    break;
		  }
	       }
	    }
            bsum += branch0[i][j];
              if( nboot > 0 ) fprintf(fpo,"%3d and %3d        %f    %6d\n",nseq+i+1,node[i][j],branch0[i][j],nw[j]);
              if( nboot == 0 ) fprintf(fpo,"%3d and %3d        %f\n",nseq+i+1,node[i][j],branch0[i][j]);
	}
      }

fprintf(fpo,"\n");
if( distflg == 0 ){
  fprintf(fpo,"%s was used. bsum=%f\n",distop[dop],bsum);
  if( dop == 7 || dop == 9 || dop == 5 ) fprintf(fpo,"gamma = %f\n",gamma);
  fprintf(fpo,"\n");
  if( dop >= 18 && dop <= 21 )  fprintf(fpo,"Number of codons compared %d (nsite=%d)\n",nasite,nsite,cdntable[ntable-1]);
  else fprintf(fpo,"Number of nucleotide sites compared %d (nsite=%d)\n",nasite,nsite);
  if( dop >= 18 && dop <= 21 ){
      fprintf(fpo,"codon table %d %s\n",ntable,cdntable[ntable-1]);
      if( ntsite != 0 ){
         fprintf(fpo,"termination codons %d:",ntsite);
         for(i=0; i<ntsite ; i++){
           fprintf(fpo," %d",tsite[i]+1);
	 }
      }
  }
        
}

if( nboot > 0 ) fprintf(fpo,"seed=%d ninap=%d accu=%e\n",seed,ninap,accu);
if( distflg == 0 ){
    if( cdnpos[0]+cdnpos[1]+cdnpos[2] != 3 ){
     fprintf(fpo,"codon position:");
     for(i=0; i<3 ; i++){
       if( cdnpos[i] == 1 ) fprintf(fpo," %d",i+1);
     }
     fprintf(fpo,"\n");
   }
  }


if( pflg == 1 ){
     rn=caldist(nseq,a,fl,nasite,asite,npsite,psite,dist,dop,fpo,gamma,bootflg,pairwiseflg,sitef,cdn,pflg,maxnm);
     prdist(fpo,nseq,dist,ncdist);
}
free_ivector(otu,nseq);
free_imatrix(spair,nseq*(nseq-1)/2,2);
free_ivector(sw,nseq*(nseq-1)/2);
free_dvector(st,nseq*(nseq-1)/2);
free_dvector(dcm,nseq);
free_dvector(rij,nseq);
free_cvector(ncn,nseq-2);
free_cvector(rlo,nseq);
free_cvector(rli,nseq-2);
free_cvector(chf,nseq-2);
free_ivector(pb,nseq-3);
free_ivector(npw,nseq-3);
free_ivector(bw,nseq-3);
free_cvector(pw1,nseq);
free_cvector(pw2,nseq);

    exit(0);
}


